package com.despark.tuning3d.model.assets
{
import by.blooddy.crypto.serialization.JSONer;

import com.despark.tuning3d.Notifications;
import com.despark.tuning3d.model.core.Tracer;
import com.despark.tuning3d.model.core.http.HttpClient;
import com.despark.tuning3d.model.core.http.caching.HttpCachePolicy;
import com.despark.tuning3d.view.core.HomeScreenPopUp;
import com.utils.DevHelper;

import flash.filesystem.File;
import flash.net.URLRequestMethod;

import org.puremvc.as3.patterns.proxy.Proxy;

import starling.utils.AssetManager;
import starling.utils.StringUtil;

public class AssetsProxy extends Proxy {
		public static const NAME : String = "AssetsProxy";

        public var httpClient : HttpClient;

		private var _assetManager : AssetManager;
		private var _delayedCompleteHandlers : Object;
		private var _scale : Number;
		public function AssetsProxy() {
			super(NAME);
		}
		
		public function set scale(value : Number) : void {
			_scale = value;
			if(!assetManager) {
				_assetManager = new AssetManager(scale);   
			}
		}
		
		public function get scale() : Number
		{
			return _scale;
		}
		
		public function removeTexture(name:String, dispose:Boolean = true):void{
            if(_assetManager.getTexture(name)){
                _assetManager.removeTexture(name, dispose);
            }
		}

		public function loadOneTexture(name:String, completeHandler:Function = null):void {
			if(_assetManager.getTexture(name)){
				if(completeHandler) {
					completeHandler(_assetManager.getTexture(name));
				}
				return 
			}
			
			_assetManager.enqueue(texturePath(name+".png"));//home && tuning
			_assetManager.loadQueue(function(ratio : Number) : void {
				if(ratio == 1) {
					if(completeHandler) {
						completeHandler(_assetManager.getTexture(name));
					}		
				}
			});
		}

        public function loadStartChallengePopupAssets(completeHandler:Function = null):void{
            enqueueTexture("accept_btn_bg", ".png", challengesPath, false);
            enqueueTexture("decline_btn_bg", ".png", challengesPath, false);
            enqueueTexture("active_label_bg", ".png", challengesPath, false);
            enqueueTexture("invitation_label_bg", ".png", challengesPath, false);
            enqueueTexture("arrow_down", ".png", challengesPath, false);
            enqueueTexture("challenges_start_accept_bg", ".png", challengesPath, false);
            enqueueTexture("garage_close", ".png", feed_friend_path, false);

            enqueueTexture("start_challenge_radio_selected", ".png", challengesPath, false);
            enqueueTexture("start_challenge_radio_default", ".png", challengesPath, false);

            enqueueTexture("back_button_clean", ".png", texturePath, true);
            enqueueTexture("details_close", ".png", texturePath, false);
            enqueueTexture("vs_large", ".png", challengesPath, false);


            enqueueTexture("challenge_random_user", ".png", challengesPath, false);
            enqueueTexture("challenge_tuning_default", ".png", challengesPath, false);
            enqueueTexture("challenge_users_default", ".png", challengesPath, false);
            enqueueTexture("rewarded_votes_img", ".png", challengesPath, false);
            enqueueTexture("challenges_accept_logo", ".png", challengesPath, false);
            enqueueTexture("challenge_rules", ".png", challengesPath, false);

            enqueueTexture("challenge_random_default", ".png", challengesPath, false);
            enqueueTexture("challenge_random_select", ".png", challengesPath, false);
            enqueueTexture("challenge_alert_background", ".png", challengesPath, false);
            enqueueTexture("challenge_alert_limit_Icon", ".png", challengesPath, false);
            enqueueTexture("challenge_alert_rewards_Icon", ".png", challengesPath, false);
            enqueueTexture("challenge_alert_default_Icon", ".png", challengesPath, false);

            enqueueTexture("timeline_my_activities_icon" ,".png", feed_friend_path, false);
            enqueueTexture("timeline_car" ,".png", feed_friend_path, false);

            enqueueTexture("searchBg", ".png", texturePath, true);
            enqueueTexture("src", ".png", texturePath, true);

            _assetManager.loadQueue(function(ratio : Number) : void{
                if (ratio == 1 && completeHandler!=null) {
                    if (completeHandler) {
                        completeHandler.call();
                    }
                }
            });
        }

        public function loadVotesListAssets(completeHandler:Function = null):void{
            enqueueTexture("header_bg", ".jpg", texturePath, true);
            enqueueTexture("searchBg", ".png", texturePath, true);
            enqueueTexture("bgOfShareMenu", ".png", texturePath, true);
            enqueueTexture("emptyButton", ".png", texturePath, true);
            enqueueTexture("a_back_button", ".png", texturePath, false);
            enqueueTexture("src", ".png", texturePath, true);

            enqueueTexture("gallery_alphabet", ".png", galleryPath, false);
            enqueueTexture("drop_down_arrow_2", ".png", galleryPath, false);
            enqueueTexture("gallery_like", ".png", galleryPath, false);

            enqueueTexture("likeButtonBg", ".png", texturePath, true);
            enqueueTexture("likeBg", ".png", texturePath, true);
            enqueueTexture("youLikeBg", ".png", texturePath, true);
            enqueueTexture("like", ".png", texturePath, true);
            _assetManager.loadQueue(function(ratio : Number) : void{
                if (ratio == 1 && completeHandler!=null) {
                    if (completeHandler) {
                        completeHandler.call();
                    }
                }
            });
        }

        public function loadBrandScreenAssets(load:Boolean = true, completeHandler:Function = null):void{
            enqueueTexture("btn_buy_coin", ".png", texturePath, false);
            enqueueTexture("a_disk_set_select", ".png", texturePath, false);
            enqueueTexture("popUpContentBackground", ".png", texturePath, true);
            //
            enqueueTexture("tuning_start_btn", ".png", texturePath, false);
            enqueueTexture("tuning_filter_btn", ".png", texturePath, false);
            enqueueTexture("tuning_post_btn", ".png", texturePath, false);

            enqueueTexture("timeline_world_icon" ,".png", feed_friend_path, false);

            enqueueTexture("a_circle_button_bg", ".png", texturePath, false);
            enqueueTexture("a_close_icon", ".png", texturePath, false);
            enqueueTexture("a_filter_icon", ".png", texturePath, false);
            enqueueTexture("a_search_icon", ".png", texturePath, false);
            enqueueTexture("last_added_icon", ".png", texturePath, false);

            enqueueTexture("drop_down_menu", ".png", texturePath, true);
            enqueueTexture("btn_buy_now", ".png", texturePath, true);
            enqueueTexture("searchBg", ".png", texturePath, true);
            enqueueTexture("bgOfShareMenu", ".png", texturePath, true);
            enqueueTexture("rewards_icon", ".png", texturePath, true);

            enqueueTexture("a_back_button", ".png", texturePath, false);
            enqueueTexture("drop_down_menu", ".png", texturePath, true);

            enqueueTexture("slide_arr_lt", ".png", texturePath, true);
            enqueueTexture("rewards_ads_icon", ".png", texturePath, true);

            enqueueTexture("featured", ".png", texturePath, true);
            enqueueTexture("featured_title", ".png", texturePath, true);
            enqueueTexture("featured_price_check", ".png", texturePath, true);
            enqueueTexture("featured_360", ".png", texturePath, true);
            enqueueTexture("up_display", ".png", texturePath, true);

            enqueueTexture("green_car_icon", ".png", texturePath, true);
            enqueueTexture("one_coin_img", ".png", texturePath, false);
            enqueueTexture("buy_3dt_coin", ".png", texturePath, false);

            enqueueTexture("car_lock_big_icon", ".png", texturePath, true);
            enqueueTexture("buy_check_icon", ".png", texturePath, true);
            enqueueTexture("offsetIcon", ".png", texturePath, true);
            enqueueTexture("stance", ".png", texturePath, true);
            enqueueTexture("ulstrarealistic", ".png", texturePath, true);
            enqueueTexture("hd-resolution", ".png", texturePath, true);
            enqueueTexture("top-vew-camera", ".png", texturePath, true);

            enqueueTexture("care_btn", ".png", texturePath, true);
            enqueueTexture("truck_icon", ".png", texturePath, true);
            enqueueTexture("muscle_icon", ".png", texturePath, true);
            enqueueTexture("src", ".png", texturePath, true);
            enqueueTexture("controlBackground", ".png", texturePath, true);
            enqueueTexture("ebay-close", ".png", texturePath, false);
            enqueueTexture("ebay-full", ".png", texturePath, false);
            enqueueTexture("ebay-full-min", ".png", texturePath, false);
            enqueueTexture("ebay-navi", ".png", texturePath, false);
            enqueueTexture("No-Info-Image-for-Buy", ".png", texturePath, true);

            enqueueTexture("tuning_bg", ".jpg", backgroundsPath, false);
            if(load) {
                _assetManager.loadQueue(function (ratio:Number):void {
                    if (ratio == 1 && completeHandler != null) {
                        if (completeHandler) {
                            completeHandler.call();
                        }
                    }
                });
            }
        }

        public function loadFlagTexture(flagId:String, load:Boolean = false, completeHandler:Function = null):void{
            enqueueTexture(flagId.toLowerCase(), ".png", flagPath, false);
            if(load) {
                _assetManager.loadQueue(function (ratio:Number):void {
                    if (ratio == 1 && completeHandler != null) {
                        if (completeHandler) {
                            completeHandler.call();
                        }
                    }
                });
            }
        }

        public function loadLeaderBoardTuning(completeHandler:Function = null):void{
            enqueueTexture("sendIcon", ".png", feed_friend_path, false);
            enqueueTexture("garage_comment_1", ".png", feed_friend_path, false);
            enqueueTexture("profile_background", ".png", challengesPath, false);
            enqueueTexture("profile_not", ".png", texturePath, false);
            enqueueTexture("a_seporator_1", ".png", texturePath, false);
            enqueueTexture("pageIndicatorSelected", ".png", texturePath, true);
            enqueueTexture("a_effect_bg", ".png", texturePath, true);
            enqueueTexture("a_delete_bg_button",".png", texturePath, false);
            enqueueTexture("a_delete_bg_button_actv",".png", texturePath, false);
            enqueueTexture("a_close_effect_menu", ".png", texturePath, false);
            enqueueTexture("a_back_button", ".png", texturePath, false);
            loadGarageSocialAssets(true, completeHandler);
        }

        public function loadMailBoxAssets(completeHandler:Function = null):void{
            enqueueTexture("garage_close", ".png", feed_friend_path, false);
            enqueueTexture("a_back_icon", ".png", texturePath, false);
            enqueueTexture("button2", ".png", texturePath, true);
            enqueueTexture("profile_background", ".png", challengesPath, false);
            enqueueTexture("sendIcon", ".png", feed_friend_path, false);
            enqueueTexture("timeline_photo" ,".png", feed_friend_path, false);
            enqueueTexture("postRectangle" ,".png", feed_friend_path, false);
            enqueueTexture("a_delete_bg_button",".png", texturePath, false);
            enqueueTexture("a_delete_bg_button_actv",".png", texturePath, false);
            enqueueTexture("details_close",".png", texturePath, false);
            enqueueTexture("garage_icon",".png", texturePath, true);

            enqueueTexture("garage_add_friend" ,".png", feed_friend_path, false);
            enqueueTexture("garage_already_friend" ,".png", feed_friend_path, false);
            enqueueTexture("garage_pending_friend" ,".png", feed_friend_path, false);
            enqueueTexture("profile_not", ".png", texturePath, false);
            enqueueTexture("a_back_button", ".png", texturePath, false);

            loadChallengeListAssets(completeHandler);
        }

        public function loadChallengeNotificationsPopupAssets(completeHandler:Function = null, loadRequest:Boolean = true):void{
            enqueueTexture("model_close", ".png", texturePath, true);
            enqueueTexture("dateIcon", ".png", feed_friend_path, false);

            enqueueTexture("challenge_accepted_icon", ".png", challengesPath, false);
            enqueueTexture("challenge_lost_icon", ".png", challengesPath, false);
            enqueueTexture("challenge_rejected_icon", ".png", challengesPath, false);
            enqueueTexture("challenge_request_icon", ".png", challengesPath, false);
            enqueueTexture("challenge_won_icon", ".png", challengesPath, false);
            enqueueTexture("vs_small", ".png", challengesPath, false);
            enqueueTexture("accept_btn_bg", ".png", challengesPath, false);
            enqueueTexture("decline_btn_bg", ".png", challengesPath, false);

            if(loadRequest){
                _assetManager.loadQueue(function(ratio : Number) : void{
                    if (ratio == 1 && completeHandler!=null) {
                        if (completeHandler) {
                            completeHandler.call();
                        }
                    }
                });
            }
        }

        public function loadChallengeTuningViewPopupAssets(completeHandler:Function = null):void{
            loadChallengeUI();

            enqueueTexture("garage_close", ".png", feed_friend_path, false);
            enqueueTexture("challenge_like_blue", ".png", challengesPath, false);
            enqueueTexture("challenge_like_red", ".png", challengesPath, false);
            enqueueTexture("vs_large", ".png", challengesPath, false);
            enqueueTexture("challenge_clock_background", ".png", challengesPath, false);
            enqueueTexture("profile_background", ".png", challengesPath, false);
            enqueueTexture("a_arrow_right_button", ".png", texturePath, false);
            enqueueTexture("profile_not", ".png", texturePath, false);
            enqueueTexture("a_close_effect_menu", ".png", texturePath, false);

            enqueueTexture("slide_arr_lt", ".png", texturePath, true);
            enqueueTexture("pageIndicator", ".png", texturePath, true);
            enqueueTexture("pageIndicatorSelected", ".png", texturePath, true);
            enqueueTexture("spinner", ".png", texturePath, true);
            _assetManager.loadQueue(function(ratio : Number) : void{
                if (ratio == 1 && completeHandler!=null) {
                    if (completeHandler) {
                        completeHandler.call();
                    }
                }
            });
        }

        public function loadChallengeLeaderBoardPopupAssets(completeHandler:Function = null):void{
            enqueueTexture("timeline_world_icon" ,".png", feed_friend_path, false);

            enqueueTexture("leaderboard_arrows_icon", ".png", challengesPath, false);
            enqueueTexture("leaderboard_car_icon", ".png", challengesPath, false);
            enqueueTexture("leaderboard_crown_icon", ".png", challengesPath, false);
            enqueueTexture("leaderboard_cup_icon", ".png", challengesPath, false);
            enqueueTexture("leaderboard_flag_icon", ".png", challengesPath, false);
            enqueueTexture("leaderboard_top_bg", ".png", challengesPath, false);
            enqueueTexture("leaderboard_bg", ".png", challengesPath, false);

            enqueueTexture("gallery_clock", ".png", galleryPath, false);
            enqueueTexture("menu_background", ".png", galleryPath, false);
            enqueueTexture("gallery_radio_default", ".png", galleryPath, false);
            enqueueTexture("gallery_radio_selected", ".png", galleryPath, false);
            enqueueTexture("drop_down_arrow", ".png", galleryPath, false);


            _assetManager.loadQueue(function(ratio : Number) : void{
                if (ratio == 1 && completeHandler!=null) {
                    if (completeHandler) {
                        completeHandler.call();
                    }
                }
            });
        }

        public function loadCustomColorAssets(completeHandler:Function = null, load:Boolean = false): void {
            enqueueTexture("popUpTitleBackground", ".png", texturePath, true);
            enqueueTexture("colorBrightness", ".png", texturePath, true);
            enqueueTexture("colorHandle", ".png", texturePath, true);
            if(load) {
                _assetManager.loadQueue(function (ratio:Number):void {
                    if (ratio == 1) {
                        if (completeHandler) {
                            completeHandler();
                        }
                    }
                });
            }
        }

        public function loadTuningScreenAssets(completeHandler:Function = null):void{
            enqueueTexture("simple_shadow", ".png", texturePath, false);
            enqueueTexture("info-bar", ".png", texturePath, true);
            enqueueTexture("ebay_info_icon", ".png", texturePath, false);
            enqueueTexture("spec-def", ".png", texturePath, false);
            enqueueTexture("official-def", ".png", texturePath, false);
            enqueueTexture("deal-loc", ".png", texturePath, false);
            enqueueTexture("shop-def", ".png", texturePath, false);
            enqueueTexture("No-Info-Image-for-Buy", ".png", texturePath, true);

            enqueueTexture("ebay-close", ".png", texturePath, false);
            enqueueTexture("ebay-full", ".png", texturePath, false);
            enqueueTexture("ebay-full-min", ".png", texturePath, false);
            enqueueTexture("ebay-navi", ".png", texturePath, false);


            enqueueTexture("a_disk_set_default", ".png", texturePath, false);
            enqueueTexture("a_disk_set_select", ".png", texturePath, false);
            enqueueTexture("color_picker_border", ".png", texturePath, false);
            enqueueTexture("engine_sound_rev_start", ".png", texturePath, false);
            enqueueTexture("engine_sound_rev_stop", ".png", texturePath, false);

            enqueueTexture("a_camera_screenshot", ".png", texturePath, false);
            enqueueTexture("a_screenshot_ar_con", ".png", texturePath, false);
            enqueueTexture("a_video_save_icon", ".png", texturePath, false);
            enqueueTexture("video_icon", ".png", texturePath, false);
            enqueueTexture("video_icon_1", ".png", texturePath, false);
            enqueueTexture("video_icon_2", ".png", texturePath, false);

            enqueueTexture("a_car_fast_mode", ".png", texturePath, false);
            enqueueTexture("a_car_fast_mode_selected", ".png", texturePath, false);
            enqueueTexture("a_fast_mode_help", ".png", texturePath, false);

            enqueueTexture("c_selector_right", ".png", texturePath, false);

            enqueueTexture("a_car_settings_button", ".png", texturePath, false);
            enqueueTexture("slider_minus", ".png", texturePath, false);
            enqueueTexture("slider_plus", ".png", texturePath, false);

            enqueueTexture("a_drag_default_button", ".png", texturePath, false);
            enqueueTexture("a_drag_selected_button", ".png", texturePath, false);

            enqueueTexture("turn5_americantrucks_selected", ".png", turn5_path, false);
            enqueueTexture("turn5_americantrucks", ".png", turn5_path, false);
            enqueueTexture("turn5_extrime_selected", ".png", turn5_path, false);
            enqueueTexture("turn5_extrime", ".png", turn5_path, false);

            enqueueTexture("stepper_left", ".png", stepper_path, false);
            enqueueTexture("stepper_right", ".png", stepper_path, false);
            enqueueTexture("stepper_minus", ".png", stepper_path, false);
            enqueueTexture("stepper_plus", ".png", stepper_path, false);
            enqueueTexture("stepper_border", ".png", stepper_path, false);

            enqueueTexture("save_lock_big_icon", ".png", texturePath, true);
            enqueueTexture("material_select", ".png", texturePath, false);

            enqueueTexture("a_open_menu", ".png", texturePath, false);
            enqueueTexture("a_close_menu", ".png", texturePath, false);

            enqueueTexture("button2", ".png", texturePath, true);
            enqueueTexture("a_selected_bg_icon", ".png", texturePath, false);

            enqueueTexture("a_seporator_1",".png", texturePath, false);
            enqueueTexture("a_show_all_disks",".png", texturePath, false);
            enqueueTexture("a_part_info_icon",".png", texturePath, false);
            enqueueTexture("new_icon",".png", texturePath, false);
            enqueueTexture("a_color_rect",".png", texturePath, false);
            enqueueTexture("a_custom_color_button",".png", texturePath, false);

            enqueueTexture("a_save_button",".png", texturePath, false);
            enqueueTexture("a_photo_accept_button",".png", texturePath, false);
            enqueueTexture("a_photo_cancel_button",".png", texturePath, false);
            enqueueTexture("engine_inactive",".png", texturePath, false);
            enqueueTexture("gas",".png", texturePath, false);
            enqueueTexture("a_paint_button",".png", texturePath, false);
            enqueueTexture("a_partslot_button",".png", texturePath, false);
            enqueueTexture("a_part_color",".png", texturePath, false);
            enqueueTexture("a_background_button",".png", texturePath, false);
            enqueueTexture("a_front_light_effect",".png", texturePath, true);
            enqueueTexture("a_new_suspension_handler",".png", texturePath, false);
            enqueueTexture("a_effect_bg", ".png", texturePath, true);
            enqueueTexture("a_disk_neon_effect", ".png", texturePath, false);
            enqueueTexture("a_color_bg_button", ".png", texturePath, false);
            enqueueTexture("a_upload_bg_button", ".png", texturePath, false);

            enqueueTexture("a_delete_bg_button",".png", texturePath, false);
            enqueueTexture("a_delete_bg_button_actv",".png", texturePath, false);

            enqueueTexture("a_back_icon", ".png", texturePath, false);
            enqueueTexture("a_arrow_right_button", ".png", texturePath, false);
            enqueueTexture("engine_active", ".png", texturePath, false);
            enqueueTexture("a_neon_effect", ".png", texturePath, false);

            enqueueTexture("a_fb_icon2", ".png", texturePath, false);
            enqueueTexture("a_instagram_icon2", ".png", texturePath, false);

            enqueueTexture("a_disk_settings_icon", ".png", texturePath, false);
            enqueueTexture("a_plus_icon", ".png", texturePath, false);
            enqueueTexture("a_disk_radius_icon", ".png", texturePath, false);
            enqueueTexture("a_minus_icon", ".png", texturePath, false);
            enqueueTexture("a_close_effect_menu", ".png", texturePath, false);
            _assetManager.loadQueue(function(ratio : Number) : void{
                if (ratio == 1 && completeHandler!=null) {
                    if (completeHandler) {
                        completeHandler.call();
                    }
                }
            });
        }

        public function loadComponentIcon(textureId:String, completeHandler:Function):void{
            if(_assetManager.isEnqueued(textureId)){
                _delayedCompleteHandlers ||= {};
                _delayedCompleteHandlers[textureId] ||= [];
                _delayedCompleteHandlers[textureId].push(completeHandler);
            }else{
                enqueueTexture(textureId, ".png", componentIconPath, false);
                _assetManager.loadQueue(function(progress : Number) : void{
                    if (progress == 1 && completeHandler!=null) {
                        if (completeHandler) {
                            completeHandler.call();
                        }
                        if(_delayedCompleteHandlers && _delayedCompleteHandlers[textureId]){
                            for(var i:int = 0; i < _delayedCompleteHandlers[textureId].length; i++){
                                _delayedCompleteHandlers[textureId][i].call();
                            }
                            delete _delayedCompleteHandlers[textureId];
                        }
                    }
                });
            }
        }

    public function loadMaterialIcon(textureId:String, completeHandler:Function):void{
            enqueueTexture(textureId, ".png", materialIconPath, false);
            _assetManager.loadQueue(function(ratio : Number) : void{
                if (ratio == 1 && completeHandler!=null) {
                    if (completeHandler) {
                        completeHandler.call();
                    }
                }
            });
        }

        public function loadChallengeUI(completeHandler:Function = null, load:Boolean = false): void {
            enqueueTexture("home_screen_page_indicator_def", ".png", texturePath, false);
            enqueueTexture("request_challenge_btn", ".png", challengesPath, false);
            enqueueTexture("challenge-countdown-challenge", ".png", challengesPath, false);
            enqueueTexture("vs_big", ".png", challengesPath, false);
            enqueueTexture("challenge-like-2", ".png", challengesPath, false);
            enqueueTexture("challenge-like-1", ".png", challengesPath, false);
            enqueueTexture("challenge-like-selected-1", ".png", challengesPath, false);
            enqueueTexture("challenge-like-selected-2", ".png", challengesPath, false);
            enqueueTexture("win", ".png", challengesPath, false);
            enqueueTexture("back_to_top", ".png", challengesPath, false);
            if(load) {
                _assetManager.loadQueue(function (ratio:Number):void {
                    if (ratio == 1) {
                        if (completeHandler) {
                            completeHandler();
                        }
                    }
                });
            }
        }

        public function loadMailScreenTextures(completeHandler:Function = null, load:Boolean = false): void {
            enqueueTexture("searchBg", ".png", texturePath, true);
            enqueueTexture("a_back_button", ".png", texturePath, false);
            enqueueTexture("src", ".png", texturePath, true);
            enqueueTexture("bgOfShareMenu", ".png", texturePath, true);
            if(load) {
                _assetManager.loadQueue(function (ratio:Number):void {
                    if (ratio == 1) {
                        if (completeHandler) {
                            completeHandler();
                        }
                    }
                });
            }
        }

        public function loadSaveTuningAssets(completeHandler:Function = null, load:Boolean = false): void {
            enqueueTexture("a_blue_bg_button", ".png", texturePath, false);
            enqueueTexture("a_transparent_bg_button", ".png", texturePath, false);
            enqueueTexture("a_text_input_bg", ".png", texturePath, false);
            if(load) {
                _assetManager.loadQueue(function (ratio:Number):void {
                    if (ratio == 1) {
                        if (completeHandler) {
                            completeHandler();
                        }
                    }
                });
            }
        }

        public function loadSharingPopupAssets(completeHandler:Function = null, load:Boolean = false): void {
            enqueueTexture("a_blue_bg_button", ".png", texturePath, false);
            enqueueTexture("a_transparent_bg_button", ".png", texturePath, false);
            enqueueTexture("a_text_input_bg", ".png", texturePath, false);
            if(load) {
                _assetManager.loadQueue(function (ratio:Number):void {
                    if (ratio == 1) {
                        if (completeHandler) {
                            completeHandler();
                        }
                    }
                });
            }
        }
		
		public function loadHomeScreenAssets(completeHandler:Function = null, load:Boolean = true) : void {
            enqueueTexture("home_screen_page_indicator_sel", ".png", texturePath, false);
            enqueueTexture("home_screen_main_menu", ".png", texturePath, false);
            enqueueTexture("avatar_background", ".png", texturePath, false);
            enqueueTexture("button", ".png", texturePath, true);
            enqueueTexture("popUpBackground", ".png", texturePath, true);
            enqueueTexture("emptyButton", ".png", texturePath, true);
            // ********** top button textures ***************
            enqueueTexture("notification", ".png", texturePath, true);
            enqueueTexture("news_btn", ".png", texturePath, true);
            enqueueTexture("login", ".png", texturePath, true);
            enqueueTexture("profile", ".png", texturePath, true);
            enqueueTexture("users-solid", ".png", texturePath, true);
            enqueueTexture("globe", ".png", texturePath, true);
            enqueueTexture("home_btn", ".png", texturePath, true);
            enqueueTexture("circle_button_bg", ".png", texturePath, true);
            enqueueTexture("logout", ".png", texturePath, true);
            // ********** Main menu texture *****************
            enqueueTexture("messages_btn", ".png", texturePath, true);
            enqueueTexture("clock-menu", ".png", texturePath, true);
            enqueueTexture("challenges_btn", ".png", texturePath, true);
            enqueueTexture("garage_icon", ".png", texturePath, true);
            enqueueTexture("gallery_icon", ".png", texturePath, true);
            enqueueTexture("shed_btn", ".png", texturePath, true);
            //
            enqueueTexture("firstScreenBg", ".jpg", texturePath, true);
            enqueueTexture("firstScreenTruckImage", ".png", texturePath, true);
            enqueueTexture("firstScreenTuningImage", ".png", texturePath, true);
            enqueueTexture("firstScreenMuscleImage", ".png", texturePath, true);
            //
            enqueueTexture("home_screen_page_indicator_def", ".png", texturePath, false);
            enqueueTexture("request_challenge_btn", ".png", challengesPath, false);
            enqueueTexture("challenge-countdown-challenge", ".png", challengesPath, false);
            enqueueTexture("spinner", ".png", texturePath, true);
            enqueueTexture("car_unlock_big_icon", ".png", texturePath, true);

            enqueueTexture("a_back_button", ".png", texturePath, false);
            enqueueTexture("sound_on_icon", ".png", texturePath, false);
            enqueueTexture("sound_off_icon", ".png", texturePath, false);

            if(load) {
                _assetManager.loadQueue(function (ratio:Number):void {
                    if (ratio == 1) {
                        if (completeHandler) {
                            completeHandler();
                        }
                    }
                });
            }
		}

        public function loadFriendsAssets(completeHandler:Function = null, load:Boolean = true) : void {
            enqueueTexture("add_friend_icon", ".png", feed_friend_path, false);
            enqueueTexture("timeline_friends_activities_icon", ".png", feed_friend_path, false);
            enqueueTexture("src", ".png", texturePath, true);
            enqueueTexture("searchBg", ".png", texturePath, true);

            enqueueTexture("add_friend", ".png", feed_friend_path, false);
            enqueueTexture("friend", ".png", feed_friend_path, false);
            enqueueTexture("swipe_remove", ".png", feed_friend_path, false);
            enqueueTexture("undo_friend", ".png", feed_friend_path, false);
            enqueueTexture("accept", ".png", feed_friend_path, false);
            enqueueTexture("decline", ".png", feed_friend_path, false);

            loadGarageSocialAssets(false);
            if(load) {
                _assetManager.loadQueue(function (ratio:Number):void {
                    if (ratio == 1) {
                        if (completeHandler) {
                            completeHandler();
                        }
                    }
                });
            }
        }

        public function loadPreviewVideoAssets(completeHandler:Function = null, load:Boolean = true) : void {
            enqueueTexture("a_bg_red_button", ".png", texturePath, false);
            enqueueTexture("a_transparent_bg_button", ".png", texturePath, false);
            enqueueTexture("a_close_effect_menu", ".png", texturePath, false);
            if(load) {
                _assetManager.loadQueue(function (ratio:Number):void {
                    if (ratio == 1) {
                        if (completeHandler) {
                            completeHandler();
                        }
                    }
                });
            }
        }



        public function loadGalleryScreenAssets(completeHandler:Function = null):void{
            loadFeedAssets(false);
            loadBrandScreenAssets(false);


            enqueueTexture("gallery_background", ".png", galleryPath, false);
            enqueueTexture("gallery_clock", ".png", galleryPath, false);
            enqueueTexture("gallery_comments", ".png", galleryPath, false);
            enqueueTexture("gallery_date", ".png", galleryPath, false);
            enqueueTexture("gallery_dir_button", ".png", galleryPath, false);
            enqueueTexture("gallery_eye", ".png", galleryPath, false);
            enqueueTexture("gallery_grid_1", ".png", galleryPath, false);
            enqueueTexture("gallery_grid_4", ".png", galleryPath, false);
            enqueueTexture("gallery_grid_9", ".png", galleryPath, false);
            enqueueTexture("gallery_like", ".png", galleryPath, false);
            enqueueTexture("menu_background", ".png", galleryPath, false);

            enqueueTexture("gallery_radio_default", ".png", galleryPath, false);
            enqueueTexture("gallery_radio_selected", ".png", galleryPath, false);

            enqueueTexture("src", ".png", texturePath, true);
            enqueueTexture("searchBg", ".png", texturePath, true);

            enqueueTexture("a_open_menu", ".png", texturePath, false);
            enqueueTexture("a_close_menu", ".png", texturePath, false);

            enqueueTexture("timeline_world_icon" ,".png", feed_friend_path, false);

            enqueueTexture("header_bg", ".jpg", texturePath, true);

            _assetManager.loadQueue(function(ratio : Number) : void{
                if (ratio == 1 && completeHandler!=null) {
                    if (completeHandler) {
                        completeHandler.call();
                    }
                }
            });
        }

        public function loadProfileScreenAssets(completeHandler:Function = null):void{
            enqueueTexture("profile_screen_background", ".png", texturePath, true);
            enqueueTexture("profile_field_bg", ".png", texturePath, false);
            enqueueTexture("profile_not", ".png", texturePath, false);
            enqueueTexture("profile_yes", ".png", texturePath, false);

            enqueueTexture("sound_on_icon", ".png", texturePath, false);
            enqueueTexture("sound_off_icon", ".png", texturePath, false);

            enqueueTexture("a_fb_icon", ".png", texturePath, false);
            enqueueTexture("a_vk_icon", ".png", texturePath, false);
            enqueueTexture("a_logout_icon", ".png", texturePath, false);

            enqueueTexture("check_new", ".png", texturePath, true);
            enqueueTexture("check_sel_new", ".png", texturePath, true);
            enqueueTexture("restoreButton", ".png", texturePath, true);

            enqueueTexture("button", ".png", texturePath, true);
            enqueueTexture("closeButton", ".png", texturePath, true);
            enqueueTexture("model_close", ".png", texturePath, true);
            enqueueTexture("bgOfShareMenu", ".png", texturePath, true);
            enqueueTexture("a_close_effect_menu", ".png", texturePath, false);

            enqueueTexture("popUpContentBackground", ".png", texturePath, true);
            enqueueTexture("a_apple_icon2", ".png", texturePath, false);

            _assetManager.loadQueue(function(ratio : Number) : void{
                if (ratio == 1 && completeHandler!=null) {
                    if (completeHandler) {
                        completeHandler.call();
                    }
                }
            });
        }

        public function loadChallengeListAssets(completeHandler:Function = null):void{
            enqueueTexture("header_bg", ".jpg", texturePath, true);
            enqueueTexture("timeline_my_activities_icon" ,".png", feed_friend_path, false);
            enqueueTexture("bgOfShareMenu", ".png", texturePath, true);
            enqueueTexture("a_back_button", ".png", texturePath, false);
            enqueueTexture("leaderboard_icon", ".png", texturePath, true);
            loadChallengeUI();
            _assetManager.loadQueue(function(ratio : Number) : void{
                if (ratio == 1 && completeHandler!=null) {
                    if (completeHandler) {
                        completeHandler.call();
                    }
                }
            });
        }

        public function loadNewsAssets(completeHandler:Function = null):void{
            enqueueTexture("icon_border", ".png", newsPath, false);
            enqueueTexture("news_tuning_icon", ".png", newsPath, false);
            enqueueTexture("news_truck_icon", ".png", newsPath, false);
            enqueueTexture("news_muscle_icon", ".png", newsPath, false);
            enqueueTexture("model_close", ".png", texturePath, true);
            enqueueTexture("a_close_effect_menu", ".png", texturePath, false);
            enqueueTexture("closeButton", ".png", texturePath, true);
            _assetManager.loadQueue(function(ratio : Number) : void{
                if (ratio == 1 && completeHandler!=null) {
                    if (completeHandler) {
                        completeHandler.call();
                    }
                }
            });
        }

        public function loadRewardsInfoAssets(completeHandler:Function = null):void{
            enqueueTexture("text", ".png", texturePath, true);
            enqueueTexture("watch", ".png", texturePath, true);
            enqueueTexture("ok", ".png", texturePath, true);
            enqueueTexture("no", ".png", texturePath, true);
            enqueueTexture("later", ".png", texturePath, true);
            enqueueTexture("a_close_effect_menu", ".png", texturePath, false);
            enqueueTexture("cancel", ".png", texturePath, true);
            _assetManager.loadQueue(function(ratio : Number) : void{
                if (ratio == 1 && completeHandler!=null) {
                    if (completeHandler) {
                        completeHandler.call();
                    }
                }
            });
        }

        public function loadRewardsConfirmAssets(completeHandler:Function = null):void{
            enqueueTexture("confirm", ".png", texturePath, true);
            enqueueTexture("frame", ".png", texturePath, false);
            enqueueTexture("cancel", ".png", texturePath, true);
            _assetManager.loadQueue(function(ratio : Number) : void{
                if (ratio == 1 && completeHandler!=null) {
                    if (completeHandler) {
                        completeHandler.call();
                    }
                }
            });
        }

        public function loadRewardsNoCoinAssets(completeHandler:Function = null):void{
            enqueueTexture("cancel", ".png", texturePath, true);
            enqueueTexture("watch", ".png", texturePath, true);
            enqueueTexture("frame", ".png", texturePath, false);
            _assetManager.loadQueue(function(ratio : Number) : void{
                if (ratio == 1 && completeHandler!=null) {
                    if (completeHandler) {
                        completeHandler.call();
                    }
                }
            });
        }

        public function loadGarageSocialAssets(load : Boolean = true, completeHandler:Function = null) : void {
            enqueueTexture("garage_vk", ".png", feed_friend_path, false);
            enqueueTexture("garage_fb", ".png", feed_friend_path, false);
            enqueueTexture("garage_close", ".png", feed_friend_path, false);

            enqueueTexture("garage_add_friend", ".png", feed_friend_path, false);
            enqueueTexture("garage_already_friend", ".png", feed_friend_path, false);
            enqueueTexture("garage_pending_friend", ".png", feed_friend_path, false);

            enqueueTexture("garage_like", ".png", feed_friend_path, false);
            enqueueTexture("garage_liked", ".png", feed_friend_path, false);
            enqueueTexture("garage_comment", ".png", feed_friend_path, false);
            enqueueTexture("garage_settings", ".png", texturePath, false);

            enqueueTexture("tuning_popup_share", ".png", texturePath, false);
            enqueueTexture("gone_to_challenge_lable", ".png", challengesPath, false);
            enqueueTexture("profile_background", ".png", challengesPath, false);
            enqueueTexture("header_bg", ".jpg", texturePath, true);

            enqueueTexture("pageIndicator", ".png", texturePath, true);
            enqueueTexture("pageIndicatorSelected", ".png", texturePath, true);
            enqueueTexture("a_close_effect_menu", ".png", texturePath, false);

            enqueueTexture("a_effect_bg", ".png", texturePath, true);
            enqueueTexture("a_delete_bg_button",".png", texturePath, false);
            enqueueTexture("a_delete_bg_button_actv",".png", texturePath, false);
            enqueueTexture("a_seporator_1",".png", texturePath, false);
            enqueueTexture("a_open_menu",".png", texturePath, false);
            enqueueTexture("a_close_menu",".png", texturePath, false);

            enqueueTexture("gallery_grid_1", ".png", galleryPath, false);
            enqueueTexture("gallery_grid_4", ".png", galleryPath, false);
            enqueueTexture("gallery_grid_9", ".png", galleryPath, false);
            enqueueTexture("gallery_clock", ".png", galleryPath, false);

            enqueueTexture("gallery_radio_default", ".png", galleryPath, false);
            enqueueTexture("gallery_radio_selected", ".png", galleryPath, false);
            enqueueTexture("drop_down_arrow", ".png", galleryPath, false);

            enqueueTexture("gallery_comments", ".png", galleryPath, false);
            enqueueTexture("gallery_date", ".png", galleryPath, false);
            enqueueTexture("gallery_eye", ".png", galleryPath, false);
            enqueueTexture("gallery_like", ".png", galleryPath, false);
            enqueueTexture("garage-winner", ".png", challengesPath, false);

            if(load) {
                _assetManager.loadQueue(function(ratio : Number) : void {
                    if (ratio == 1) {
                        if(completeHandler) {
                            completeHandler();
                        }
                    }
                });

            }

        }



        public function loadFeedAssets(load:Boolean = true, completeHandler:Function = null):void {
            loadGarageSocialAssets(false);

            enqueueTexture("vs_small", ".png", challengesPath, false);
            enqueueTexture("challenge_winner", ".png", challengesPath, false);
            enqueueTexture("timeline_filter_default", ".png", feed_friend_path, false);
            enqueueTexture("timeline_filter_selected", ".png", feed_friend_path, false);
            enqueueTexture("sendIcon", ".png", feed_friend_path, false);
            enqueueTexture("timeline_rate_filter_bg", ".png", feed_friend_path, false);
            enqueueTexture("timeline_feed_border", ".png", feed_friend_path, false);

            enqueueTexture("profile_background", ".png", challengesPath, false);


            enqueueTexture("commentIcon", ".png", feed_friend_path, false);//feed
            enqueueTexture("likeIcon", ".png", feed_friend_path, false);//feed
            enqueueTexture("post_friend_icon" ,".png", feed_friend_path, false);//feed
            enqueueTexture("post_icon" ,".png", feed_friend_path, false);//feed
            //_assetManager.enqueufeed_friend_pathth("post_like_icon.png"		,false));//feed
            enqueueTexture("post_like_icon" ,".png", feed_friend_path, false);//feed
            enqueueTexture("post_photo_icon" ,".png", feed_friend_path, false);//feed
            enqueueTexture("post_tuning_icon" ,".png", feed_friend_path, false);//feed

            enqueueTexture("post_challenge_accept_icon" ,".png", feed_friend_path, false);//feed
            enqueueTexture("post_challenge_win_icon" ,".png", feed_friend_path, false);//feed

            enqueueTexture("postRectangle" ,".png", feed_friend_path, false);//feed
            enqueueTexture("back_to_top", ".png", challengesPath, false);


            enqueueTexture("dateIcon" ,".png", feed_friend_path, false);
            enqueueTexture("timelineComment" ,".png", feed_friend_path, false);
            enqueueTexture("timeline_like_big" ,".png", feed_friend_path, false);
            enqueueTexture("timeline_car" ,".png", feed_friend_path, false);
            enqueueTexture("timeline_photo" ,".png", feed_friend_path, false);
            enqueueTexture("timeline_edit_rect" ,".png", feed_friend_path, false);

            enqueueTexture("timeline_my_activities_icon" ,".png", feed_friend_path, false);
            enqueueTexture("timeline_friends_activities_icon" ,".png", feed_friend_path, false);
            enqueueTexture("a_open_menu_iphonex",".png", texturePath, false);


            enqueueTexture("round_btn_border",".png", texturePath, false);
            enqueueTexture("round_btn_border_sel",".png", texturePath, false);
            enqueueTexture("cancel_button_bg",".png", texturePath, false);
            enqueueTexture("tuning_del_icon",".png", texturePath, false);
            enqueueTexture("frame_del_icon",".png", texturePath, false);
            enqueueTexture("a_delete_bg_button_actv",".png", texturePath, false);
            enqueueTexture("a_edit_bg_button",".png", texturePath, false);

            enqueueTexture("header_bg", ".jpg", texturePath, true);

            enqueueTexture("tuning_new_btn", ".png", texturePath, false);
            enqueueTexture("tuning_edit_btn", ".png", texturePath, false);
            if(load) {
                _assetManager.loadQueue(function (ratio:Number):void {
                    if (ratio == 1) {
                        if (completeHandler) {
                            completeHandler();
                        }
                    }
                });
            }
        }

		public function loadUpdateText(callBack : Function) : void {
			httpClient.loadPath("", URLRequestMethod.GET, null, HttpCachePolicy.INTERNET_FIRST, false, function (success : Boolean, result : Object) : void {
				if(success) {
					var obj : Object = JSONer.parse(result);
					HomeScreenPopUp.UPDATE_OBJECT = obj["new"]["app"];
				}

				if(callBack) {
					callBack.call();
				}
            }, HttpClient.API_DOMAIN + "/api/v1/update-texts?lang=en-US");
		}
		
		public function loadAssets(completeHandler : Function = null) : void {
            Tracer.timeStamp('assets', 'load');
			loadHomeScreenAssets();
            loadChallengeUI();
			// ebay/amazon
            _assetManager.enqueue(texturePath("info-bar.png"));
            _assetManager.enqueue(texturePath("spec-def.png",false));
            _assetManager.enqueue(texturePath("deal-loc.png",false));
            _assetManager.enqueue(texturePath("shop-def.png",false));
            _assetManager.enqueue(texturePath("official-def.png",false));
            _assetManager.enqueue(texturePath("ebay_info_icon.png",false));
            _assetManager.enqueue(texturePath("ebay-close.png",false));
            _assetManager.enqueue(texturePath("ebay-full.png",false));
            _assetManager.enqueue(texturePath("ebay-full-min.png",false));
            _assetManager.enqueue(texturePath("ebay-navi.png",false));
            _assetManager.enqueue(texturePath("simple_shadow.png", false));
            _assetManager.enqueue(texturePath("No-Info-Image-for-Buy.jpg"));
			
			DevHelper._log("loadAssets");
            // SHEDULE
			_assetManager.enqueue(texturePath("like.png"));//Scagle
            _assetManager.enqueue(texturePath("likeBg.png"));//Vote
            _assetManager.enqueue(texturePath("likeButtonBg.png"));//schagle
            _assetManager.enqueue(texturePath("pageIndicator.png"));//garage &&
            _assetManager.enqueue(texturePath("pageIndicatorSelected.png"));//garage &&
            _assetManager.enqueue(texturePath("a_bg_red_button.png", false));//tuning

            /*All*/
            _assetManager.enqueue(texturePath("textField.png"));//??
            _assetManager.enqueue(texturePath("popUpBackground.png"));//??
            _assetManager.enqueue(texturePath("popUpTitleBackground.png"));//??
            _assetManager.enqueue(texturePath("popUpContentBackground.png"));//??
            _assetManager.enqueue(texturePath("spinner.png"));//allPage
            _assetManager.enqueue(texturePath("button2.png"));//??
            _assetManager.enqueue(texturePath("closeButton.png"));//??
            _assetManager.enqueue(texturePath("button.png"));//??
			_assetManager.enqueue(texturePath("a_instagram_icon2.png", false));//tuning
			_assetManager.enqueue(texturePath("a_vk_icon2.png", false));//tuning
			_assetManager.enqueue(texturePath("a_fb_icon2.png", false));//tuning
            _assetManager.enqueue(texturePath("a_apple_icon2.png", false));//tuning
			_assetManager.enqueue(texturePath("a_tw_icon2.png", false));//tuning
			_assetManager.enqueue(texturePath("a_seporator_1.png", false));//tuning
			_assetManager.enqueue(texturePath("a_effect_bg.png"));//tuning
			_assetManager.enqueue(texturePath("a_delete_bg_button.png", false));//tuning
			_assetManager.enqueue(texturePath("a_edit_bg_button.png", false));//tuning
			_assetManager.enqueue(texturePath("a_open_menu.png", false));//tuning

            /*Home*/
            _assetManager.enqueue(texturePath("slide_arr_lt.png")); //home
            _assetManager.enqueue(texturePath("drop_down_menu.png"));//home
            _assetManager.enqueue(texturePath("root_title_bar.png")); //home
            _assetManager.enqueue(texturePath("src.png")); //home
            _assetManager.enqueue(texturePath("up_display.png"));//home
            _assetManager.enqueue(texturePath("make_bg_top2.png"));//home
            _assetManager.enqueue(texturePath("model_close.png"));//home
            _assetManager.enqueue(texturePath("model_close_fl.png"));//home
            _assetManager.enqueue(texturePath("model_fullscr.png")); //home
            _assetManager.enqueue(texturePath("model_search_open.png"));//home
            _assetManager.enqueue(texturePath("model_search_open_bg.png"));//home???????
            _assetManager.enqueue(texturePath("clearInput.png"));// home
            _assetManager.enqueue(texturePath("stance.png"));//home
            _assetManager.enqueue(texturePath("top-vew-camera.png")); //home
            _assetManager.enqueue(texturePath("hd-resolution.png")); //home
            _assetManager.enqueue(texturePath("textFieldWhite.png"));//home
            _assetManager.enqueue(texturePath("offsetIcon.png"));//home
            _assetManager.enqueue(texturePath("ulstrarealistic.png"));//home
            _assetManager.enqueue(texturePath("restoreButton.png"));//payed
            _assetManager.enqueue(texturePath("restoreIcon.png"));//??payed
            _assetManager.enqueue(texturePath("searchBg.png")); // home
            _assetManager.enqueue(texturePath("searchIcon.png")); // home
			_assetManager.enqueue(texturePath("buy_check_icon.png"));//home

            /*Menu*/
            _assetManager.enqueue(texturePath("main_menu_bg.png"));//menu
            _assetManager.enqueue(texturePath("care_btn.png"));//menu
            _assetManager.enqueue(texturePath("garage_icon.png"));//menu
            _assetManager.enqueue(texturePath("truck_icon.png"));//menu
            _assetManager.enqueue(texturePath("muscle_icon.png"));//menu
            _assetManager.enqueue(texturePath("gallery_icon.png"));//menu
            _assetManager.enqueue(texturePath("home_btn.png"));//menu
            _assetManager.enqueue(texturePath("shed_btn.png"));//menu
            _assetManager.enqueue(texturePath("bgOfShareMenu.png"));//??
            _assetManager.enqueue(texturePath("instructionButton.png"));//??
            _assetManager.enqueue(texturePath("emptyButton.png"));//???
            _assetManager.enqueue(texturePath("roundRect.png"));//??
            _assetManager.enqueue(texturePath("challenges_btn.png"));//??
            _assetManager.enqueue(texturePath("messages_btn.png"));//??
            _assetManager.enqueue(texturePath("challenges_notes_btn.png"));//??
            _assetManager.enqueue(texturePath("leaderboard_icon.png"));//??

            _assetManager.enqueue(texturePath("circle_button_bg.png")); // default circle button background
            _assetManager.enqueue(texturePath("restore.png")); // main menu restore button icon
            _assetManager.enqueue(texturePath("profile.png")); // main menu profile button icon
            _assetManager.enqueue(texturePath("logout.png")); // main menu logout button icon
            _assetManager.enqueue(texturePath("login.png")); // main menu logout button icon

            _assetManager.enqueue(texturePath("globe.png"));//??
            _assetManager.enqueue(texturePath("users-solid.png"));//??
            _assetManager.enqueue(texturePath("clock-menu.png"));//??


            /*Featured*/
            _assetManager.enqueue(texturePath("car_lock_big_icon.png"));//payed
            _assetManager.enqueue(texturePath("featured_price_check.png"));//payeed
            _assetManager.enqueue(texturePath("featured_title.png"));////payed
            _assetManager.enqueue(texturePath("featured.png"));//payed??
            _assetManager.enqueue(texturePath("featured_360.png"));//payed
            _assetManager.enqueue(texturePath("youLikeBg.png"));
            _assetManager.enqueue(texturePath("btn_buy_now.png"));//??
            _assetManager.enqueue(texturePath("green_car_icon.png"));//??
            _assetManager.enqueue(texturePath("controlBackground.png"));
			_assetManager.enqueue(texturePath("car_unlock_big_icon.png"));//??
			_assetManager.enqueue(texturePath("checkIcon.png"));//Payment
			_assetManager.enqueue(texturePath("one_coin_img.png", false));//Payment
			_assetManager.enqueue(texturePath("buy_3dt_coin.png", false));//Payment

            /*Login reg*/
            _assetManager.enqueue(texturePath("check.png"));//??
            _assetManager.enqueue(texturePath("checkSelected.png"));//??
            _assetManager.enqueue(texturePath("backButton.png"));//replace
			_assetManager.enqueue(texturePath("a_blue_bg_button.png", false));//tuning
			_assetManager.enqueue(texturePath("a_transparent_bg_button.png", false));//tuning
			_assetManager.enqueue(texturePath("a_photo_accept_button.png", false));
			_assetManager.enqueue(texturePath("a_photo_cancel_button.png", false));
			
			/*Tuning Car*/
			_assetManager.enqueue(texturePath("a_arrow_right_button.png", false));//tuning
			_assetManager.enqueue(texturePath("a_close_menu.png", false));//tuning
			_assetManager.enqueue(texturePath("a_back_icon.png", false));//tuning
			_assetManager.enqueue(texturePath("a_minus_icon.png", false));//tuning
			_assetManager.enqueue(texturePath("a_background_button.png", false));//tuning
			_assetManager.enqueue(texturePath("a_neon_effect.png"));//tuning
			_assetManager.enqueue(texturePath("a_burger_button.png", false));//tuning
			_assetManager.enqueue(texturePath("a_back_button.png", false));//tuning
			_assetManager.enqueue(texturePath("a_paint_button.png", false));//tuning
			_assetManager.enqueue(texturePath("a_close_effect_menu.png", false));//tuning
			_assetManager.enqueue(texturePath("a_part_info_icon.png", false));//tuning			
			_assetManager.enqueue(texturePath("a_color_bg_button.png", false));//tuning
			_assetManager.enqueue(texturePath("a_partslot_bg.png", false));//tuning
			_assetManager.enqueue(texturePath("a_color_rect.png", false));//tuning
			_assetManager.enqueue(texturePath("a_partslot_bg_selected.png", false));//tuning
			_assetManager.enqueue(texturePath("a_custom_color_button.png", false));//tuning
			_assetManager.enqueue(texturePath("a_partslot_button.png", false));//tuning		
			_assetManager.enqueue(texturePath("a_photo_bg_button.png", false));//tuning
			_assetManager.enqueue(texturePath("a_disk_left_icon.png", false));//tuning
			_assetManager.enqueue(texturePath("a_disk_left_right_icon.png", false));//tuning
			_assetManager.enqueue(texturePath("a_plus_icon.png", false));//tuning
			_assetManager.enqueue(texturePath("a_disk_neon_effect.png", false));//tuning
			_assetManager.enqueue(texturePath("a_disk_ofset_1.png", false));//tuning
			_assetManager.enqueue(texturePath("a_save_button.png", false));//tuning
			_assetManager.enqueue(texturePath("a_disk_ofset_1_selected.png", false));//tuning
			_assetManager.enqueue(texturePath("a_selected_bg_icon.png", false));//tuning
			_assetManager.enqueue(texturePath("a_disk_ofset_2.png", false));//tuning		
			_assetManager.enqueue(texturePath("a_disk_ofset_2_selected.png", false));//tuning
			_assetManager.enqueue(texturePath("a_disk_radius_icon.png", false));//tuning
			_assetManager.enqueue(texturePath("a_disk_right_icon.png", false));//tuning
			_assetManager.enqueue(texturePath("a_disk_settings_icon.png", false));//tuning
			_assetManager.enqueue(texturePath("a_upload_bg_button.png", false));//tuning
			_assetManager.enqueue(texturePath("a_front_light_effect.png"));//tuning
			_assetManager.enqueue(texturePath("a_part_color.png", false));//tuning
			_assetManager.enqueue(texturePath("a_show_all_disks.png", false));//tuning
			_assetManager.enqueue(texturePath("a_text_input_bg.png", false));//tuning		
			_assetManager.enqueue(texturePath("a_new_suspension_line.png"));//tuning
			_assetManager.enqueue(texturePath("a_new_suspension_handler.png", false));//tuning		
			_assetManager.enqueue(texturePath("a_loader_sq_full.png", false));//tuning
			_assetManager.enqueue(texturePath("a_loader_sq_1_2.png", false));//tuning
			_assetManager.enqueue(texturePath("a_loader_sq_empty.png", false));//tuning			
			_assetManager.enqueue(texturePath("a_loading_background.png"));//tuning
			_assetManager.enqueue(texturePath("new_icon.png", false));//tuning
			_assetManager.enqueue(texturePath("colorHandle.png")); //tuning
			_assetManager.enqueue(texturePath("colorBrightness.png"));//tuning

            _assetManager.enqueue(texturePath("engine_active.png", false));//tuning
            _assetManager.enqueue(texturePath("engine_inactive.png", false));//tuning
            _assetManager.enqueue(texturePath("gas.png", false) );//tuning



			_assetManager.enqueue(texturePath("cancel.png"));
            _assetManager.enqueue(texturePath("confirm.png"));
            _assetManager.enqueue(texturePath("later.png"));
            _assetManager.enqueue(texturePath("no.png"));
            _assetManager.enqueue(texturePath("ok.png"));
            _assetManager.enqueue(texturePath("rewards_ads_icon.png"));
            _assetManager.enqueue(texturePath("text.png"));
            _assetManager.enqueue(texturePath("watch.png"));
            _assetManager.enqueue(texturePath("rewards_icon.png"));
			_assetManager.enqueue(texturePath("notification.png"));
            _assetManager.enqueue(texturePath("frame.png", false));

            _assetManager.enqueue(texturePath("sound_on_icon.png", false));
            _assetManager.enqueue(texturePath("sound_off_icon.png", false));

            Tracer.timeStamp('assets', 'loadQueue');

			_assetManager.loadQueue(function(ratio : Number) : void 
			{
				if(ratio == 1) 
				{
					if(completeHandler)
							completeHandler();

					sendNotification(Notifications.ASSETS_LOADED);
                    Tracer.timeStamp('assets', 'finish');
				}
			});
		}
		
		private function texturePath(texture : String, hasScales : Boolean = true) : File {
			var appDirectory : File = File.applicationDirectory;
			var path : File;
			
			if(hasScales) {
				var scale : Number = _assetManager.scaleFactor;
				path = appDirectory.resolvePath(StringUtil.format("assets/textures/{0}x/{1}", scale, texture));
			} else {
				path = appDirectory.resolvePath(StringUtil.format("assets/textures/{1}", scale, texture));
			}
			path.preventBackup = true;
			
			return path;
		}

        private function feed_friend_path(texture:String, hasScales : Boolean = true) : File {
            texture = 'feed-friends/' + texture;
            return texturePath(texture, false);
        }

        private function turn5_path(texture:String, hasScales : Boolean = true) : File {
            texture = 'turn5_logos/' + texture;
            return texturePath(texture, false);
        }

        private function stepper_path(texture:String, hasScales : Boolean = true) : File {
            texture = 'value_stepper/' + texture;
            return texturePath(texture, false);
        }

        private function flagPath(texture:String, hasScale:Boolean = false) : File {
            texture = 'flags/' + texture;
            return texturePath(texture, false);
        }

        private function galleryPath(texture:String, hasScales : Boolean = true) : File {
            texture = 'gallery/' + texture;

            return texturePath(texture, false);
        }

        private function challengesPath(texture:String, hasScales : Boolean = false) : File {
            texture = 'challenges/' + texture;
            return texturePath(texture, hasScales);
        }

        private function newsPath(texture:String, hasScales : Boolean = false) : File {
            texture = 'news/' + texture;
            return texturePath(texture, hasScales);
        }

        private function componentIconPath(texture:String, hasScales : Boolean = false) : File {
            texture = 'component_icons/' + texture;
            return texturePath(texture, hasScales);
        }

        private function materialIconPath(texture:String, hasScales : Boolean = false) : File {
            texture = 'finish_type_icons/' + texture;
            return texturePath(texture, hasScales);
        }

        private function backgroundsPath(texture:String, hasScales : Boolean = false) : File {
            texture = 'bgs/' + texture;
            return texturePath(texture, hasScales);
        }
		
		public function get assetManager() : AssetManager {
			return _assetManager;
		}

        private function enqueueTexture(textureId:String, fileFormat:String, pathMethod:Function, hasScale:Boolean = true):void{
            if(!_assetManager.getTexture(textureId) && !_assetManager.isEnqueued(textureId)){
                _assetManager.enqueue(pathMethod(textureId + fileFormat, hasScale));
            }
        }
	}
}