package com.despark.tuning3d.view {
    import com.despark.tuning3d.model.users.UsersProxy;
    import com.despark.tuning3d.view.components.core.AlertView;
    import com.despark.tuning3d.view.components.core.BannerStackedScreen;
    import com.despark.tuning3d.view.components.core.PopUp;
    import com.despark.tuning3d.view.components.news.NewsPopUp;
    import com.despark.tuning3d.view.components.timeline.FeedData;
    import com.despark.tuning3d.view.core.PopUpMediator;
    import com.utils.ArrayUtil;
    import com.utils.Tracker;

    public class NewsPopUpMediator extends PopUpMediator{

    private var _loadingAlert:AlertView;

    public function NewsPopUpMediator(popUp:PopUp) {
        super(popUp);
        var usersProxy : UsersProxy = facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
        FeedData.CURRENT_USER = usersProxy.currentUser;
    }

    override public function onRegister():void {
        super.onRegister();
        Tracker.trackEvent("Notifications Popup", "open");
        BannerStackedScreen.hideAdBanner(false);
    }

    override public function onRemove():void {
        super.onRemove();

        if(_loadingAlert && _loadingAlert.parent)
        {
            _loadingAlert.hide();
        }
        _loadingAlert = null;
    }

    override public function listNotificationInterests() : Array {
        return ArrayUtil.uniqueConcat(super.listNotificationInterests(), [
        ]);
    }
}
}
