package com.despark.tuning3d.view.components.brands {
    import com.despark.tuning3d.model.brands.Brand;
    import com.despark.tuning3d.model.brands.Brand;
    import com.despark.tuning3d.model.cars.Car;
    import com.despark.tuning3d.model.core.AppMode;
    import com.despark.tuning3d.model.core.Device;
    import com.despark.tuning3d.model.sounds.SoundManager;
    import com.despark.tuning3d.view.components.cars.CarItemRenderer;
    import com.despark.tuning3d.view.components.core.BannerStackedScreen;
    import com.despark.tuning3d.view.components.core.ButtonFactory;
    import com.despark.tuning3d.view.components.core.ExtendedList;
    import com.despark.tuning3d.view.components.core.LabelFactory;
    import com.despark.tuning3d.view.components.gallery.SearchInput;
    import com.utils.ArrayUtil;
    import com.utils.Console;
    import com.utils.DisplayObjectUtil;

    import feathers.controls.Button;
    import feathers.controls.Label;
    import feathers.controls.LayoutGroup;
    import feathers.controls.ScrollBar;
    import feathers.controls.ScrollBarDisplayMode;
    import feathers.controls.ScrollContainer;
    import feathers.controls.ScrollPolicy;
    import feathers.controls.ToggleButton;
    import feathers.controls.renderers.IListItemRenderer;
    import feathers.core.ToggleGroup;
    import feathers.data.ListCollection;
    import feathers.layout.Direction;
    import feathers.layout.HorizontalAlign;
    import feathers.layout.HorizontalLayout;
    import feathers.layout.TiledRowsLayout;
    import feathers.layout.VerticalAlign;
    import feathers.layout.VerticalLayout;

    import mx.utils.StringUtil;

    import starling.core.Starling;
    import starling.display.Quad;
    import starling.display.Sprite;
    import starling.events.Event;
    import starling.utils.ScaleMode;

    public class BrandScreenCarChooser extends LayoutGroup {
        private var _brandsList:ExtendedList;
        private var _carsList:CarsList;
        //
        private var _closeButton:Button;
        private var _searchButton:SearchInput;
        // private var _filterButton:Button;
        private var _topButtonsMenu:LayoutGroup;
        private var _typeMenu:ScrollContainer;
        private var brandListTopBorder:Quad;
        private var brandListBottomBorder:Quad;

        private var carsListTopBorder:Quad;

        private var bodyTypesList:Array = [];
        private var typeToggleGroup:ToggleGroup;
        public var brandsScreen:BrandsScreen;
        private var _car_filter:String = "";
        private var _brands:Array;
        private var _filteredCars:Array;
        private var _sideMargin:Number = 0;
        private var _messageLabel : Label;
        private static const bodyTypeLabels:Object = function():Object{
            var result:Object = {};
            result[AppMode.MODE_TUNING] = [
                {name:'CABRIO', value:'Convertible'},
                {name:'Coupe', value:'Coupe'},
                {name:'HATCH', value:'Hatchback'},
                {name:'Sedan', value:'Sedan'},
                {name:'Wagon', value:'Wagon'},
                {name:'SUV', value:'SUV'},
                {name:'Van', value:'Van'},
                {name:"SEMI'S", value:'Semi Truck'},
                {name:'BIKE', value:'Motorcycle'}
            ];
            result[AppMode.MODE_TRUCK_CONFIGURATOR] = [
                {name:'Crew Cab', value:'Crew Cab'},
                {name:'Extended Cab', value:'Extended Cab'},
                {name:'Reg Cab', value:'Reg Cab'},
                {name:'DRW', value:'DRW'}
            ];
            result[AppMode.MODE_AMERICAN_MUSCLE] = [
                {name:'Convertible', value:'Convertible'},
                {name:'Coupe', value:'Coupe'},
                {name:'Sedan', value:'Sedan'},
                {name:'Hatchback', value:'Hatchback'}
            ];
            for(var key:String in result){
                for(var i:int = 0; i < result[key].length; i++){
                    result[key][i].name = result[key][i].name.toUpperCase();
                    result[key][i].value = result[key][i].value.toUpperCase();
                }
            }
            return result;
        }();

        public function BrandScreenCarChooser() {
            super();
        }

        override protected function initialize():void{
            super .initialize();
            backgroundSkin = new Quad(1, 1, 0x252525);
            _sideMargin = Device.isIphoneXVariant()?24:0;

            width = stage.stageWidth;
            height = stage.stageHeight;
            typeToggleGroup = new ToggleGroup();

            _topButtonsMenu = new LayoutGroup();
            var topMenuLayoutData:HorizontalLayout = new HorizontalLayout();
            topMenuLayoutData.verticalAlign = VerticalAlign.MIDDLE;
            topMenuLayoutData.gap = 12.5;
            _topButtonsMenu.layout = topMenuLayoutData;
            _topButtonsMenu.height = BannerStackedScreen.BANNER_SIZE;


            _typeMenu = new ScrollContainer();
            var typeMenuLayoutData:HorizontalLayout = new HorizontalLayout();
            typeMenuLayoutData.verticalAlign = VerticalAlign.MIDDLE;
            typeMenuLayoutData.horizontalAlign = HorizontalAlign.LEFT;
            typeMenuLayoutData.gap = 0;
            _typeMenu.layout = typeMenuLayoutData;
            _typeMenu.height = BannerStackedScreen.BANNER_SIZE;
            _typeMenu.horizontalScrollPolicy = ScrollPolicy.AUTO;
            _typeMenu.scrollBarDisplayMode = ScrollBarDisplayMode.FIXED;
            addChild(_typeMenu);


/*
            _filterButton = ButtonFactory.circleDefaultButton2("a_filter_icon", 0.6, 0xFFFFFE, 0, 0x3d3d3d);
            _topButtonsMenu.addChild(_filterButton);*/

            _searchButton = new SearchInput(false, 26, "a_search_icon", ScaleMode.NONE, 0x3d3d3d, true);
            _topButtonsMenu.addChild(_searchButton);
            _searchButton.addEventListener(Event.CHANGE, searchChangeHandler);

            _closeButton = ButtonFactory.circleDefaultButton2("a_close_icon", 0.6, 0xFFFFFE, 0, 0x3d3d3d);
            _closeButton.addEventListener(Event.TRIGGERED, closeButtonTriggeredHandler);
            _topButtonsMenu.addChild(_closeButton);


            brandListTopBorder = new Quad(1, 1, 0x4b4b4b);
            addChild(brandListTopBorder);
            brandListBottomBorder = new Quad(1, 1, 0x4b4b4b);
            addChild(brandListBottomBorder);

            var brandsLayout : VerticalLayout = new VerticalLayout();
            brandsLayout.scrollPositionVerticalAlign = VerticalAlign.TOP;
            brandsLayout.useVirtualLayout = true;
            brandsLayout.gap = 0;
            _brandsList = new ExtendedList();
            _brandsList.scrollBarDisplayMode = ScrollBarDisplayMode.FLOAT;
            _brandsList.clipContent = true;
            _brandsList.addEventListener(Event.CHANGE, brandsListChangeHandler);
            _brandsList.layout = brandsLayout;
            _brandsList.itemRendererFactory = brandsListItemRendererFactory;
            addChild(_brandsList);

            var carsLayout : TiledRowsLayout = new TiledRowsLayout();
            carsLayout.requestedColumnCount = 3;
            carsLayout.useSquareTiles = false;
            carsLayout.verticalAlign = VerticalAlign.TOP;
            carsLayout.horizontalAlign = HorizontalAlign.LEFT;
            carsLayout.useVirtualLayout = true;
            carsLayout.gap = 0;
            _carsList = new CarsList();
            _carsList.name = "carsList";
            _carsList.clipContent = true;
            _carsList.layout = carsLayout;
            _carsList.verticalScrollPolicy = ScrollPolicy.AUTO;

            _carsList.addEventListener(Event.CHANGE, carsListChangeHandler);
            _carsList.scrollBarDisplayMode = ScrollBarDisplayMode.FIXED;
            _carsList.verticalScrollBarFactory = verticalScrollBarFactory;
            _carsList.itemRendererFactory = carsListItemRendererFactory;
            addChild(_carsList);

            carsListTopBorder = new Quad(1, 1, 0x4b4b4b);
            addChild(carsListTopBorder);
            addChild(_topButtonsMenu);

            _messageLabel = new Label();
            _messageLabel.includeInLayout = false;
            _messageLabel.visible = false;
            _messageLabel.height = 14;
            _messageLabel.textRendererFactory = LabelFactory.profileButtonLabel;
            _messageLabel.text = "No search results found";
            _messageLabel.width = actualWidth;
            addChild(_messageLabel);

        }

        private function searchChangeHandler(event:Event):void {
            _brandsList.removeEventListener(Event.CHANGE, brandsListChangeHandler);
            _brandsList.selectedIndex = 0;

            if(typeToggleGroup.selectedIndex != 0){
                typeToggleGroup.removeEventListener(Event.CHANGE, typeGroupChangeHandler);
                typeToggleGroup.selectedIndex = 0;
                typeToggleGroup.addEventListener(Event.CHANGE, typeGroupChangeHandler);
            }
            _car_filter = StringUtil.trim(_searchButton.text).toLowerCase();
            brandsListChangeHandler(null);
            var brandsArr:Array;
            if(_car_filter.length){
                brandsArr = _brands.concat();
                var ln:int = brandsArr.length - 1;
                for(var i:int = ln; i >= 0; i--){
                    for(var j:int = 0; j < _filteredCars.length; j++){
                        if(Brand(brandsArr[i]).cars.indexOf(_filteredCars[j]) != -1){
                            break;
                        }
                    }
                    if(j == _filteredCars.length){
                        brandsArr.removeAt(i);
                    }
                }
            }else{
                brandsArr = _brands;
            }

            _brandsList.dataProvider = new ListCollection(brandsArr);
            _brandsList.addEventListener(Event.CHANGE, brandsListChangeHandler);
            _brandsList.selectedIndex = 0;
        }

        private function brandsListChangeHandler(event:Event) : void {
            var selectedCarBrand : Brand = _brandsList.selectedItem as Brand;
            if (selectedCarBrand == null) {
                selectedCarBrand = _brands[0] as Brand;
            }
            if(_brandsList.visible){
                SoundManager.playSound(SoundManager.SELECT_PART);
            }

            var showBrand : Boolean = selectedCarBrand && (selectedCarBrand.lastAdded || selectedCarBrand.limitedOption || selectedCarBrand.name == "ALL");
            _filteredCars = filteredCarsList;
            var selectedCars:Array = [];
            for(var i:int = 0; i < _filteredCars.length; i++){
                if(Car(_filteredCars[i]).limitedOptions == selectedCarBrand.limitedOption){
                    selectedCars.push(_filteredCars[i]);
                }
            }
            var collection : ListCollection = new ListCollection(selectedCars);
            _carsList.showBrandName = showBrand;
            _carsList.dataProvider = collection;
            _carsList.data = {
                showBrand : showBrand
            }

            _messageLabel.visible = (collection.length == 0);
            brandListBottomBorder.visible = !_messageLabel.visible;
        }


        private function carsListChangeHandler(event : Event) : void {
            if (AppMode.self.mode == AppMode.MODE_TUNING) {
                close();
                if (_carsList.selectedItem) {
                    SoundManager.playSound(SoundManager.SELECT_PART);
                    brandsScreen.dispatchEventWith(BrandsScreen.CAR_SELECTED, false, _carsList.selectedItem);
                    if (_carsList) {
                        _carsList.selectedIndex = -1;
                    }
                }
            } else if (AppMode.self.mode == AppMode.MODE_TRUCK_CONFIGURATOR || AppMode.self.mode == AppMode.MODE_AMERICAN_MUSCLE) {

                if(_carsList.selectedItem) {
                    var selectedCar:Car = _carsList.selectedItem as Car;
                    var containsCar:Boolean = false;
                    if (brandsScreen.featuredCarsList.dataProvider.contains(_carsList.selectedItem)) {
                        containsCar = true;
                    } else {
                        for (var i:int = 0; i < brandsScreen.featuredCarsList.dataProvider.length; i++) {
                            if (brandsScreen.featuredCarsList.dataProvider.getItemAt(i).id == selectedCar.id) {
                                selectedCar = brandsScreen.featuredCarsList.dataProvider.getItemAt(i) as Car;
                                containsCar = true;
                                break;
                            }
                        }
                    }

                    if (containsCar) {
                        brandsScreen.brandListButton.label = BrandsScreen.getCarLabel(selectedCar);
                        brandsScreen.featuredCarsList.removeEventListener(Event.CHANGE, brandsScreen.featuredCarListChangeHandler);
                        brandsScreen.featuredCarsList.selectedItem = selectedCar;
                        brandsScreen.featuredCarsList.scrollToPageIndex(brandsScreen.featuredCarsList.selectedIndex, 0, 1);
                        brandsScreen.featuredCarsList.selectedIndex = -1;
                        brandsScreen.featuredCarsList.addEventListener(Event.CHANGE, brandsScreen.featuredCarListChangeHandler);
                        close();
                    } else {
                        brandsScreen.dispatchEventWith(BrandsScreen.CAR_SELECTED, false, selectedCar);
                        close();
                    }
                }
            }
        }


        private function  carsListItemRendererFactory() : IListItemRenderer {
            var renderer : CarItemRenderer = new CarItemRenderer();
            renderer.setSize((_carsList.width - _carsList.paddingRight - _carsList.paddingLeft - 17) / 3, (_carsList.height - 1) / 3);
            renderer._carOffset = 7;
            return renderer;
        }


        private function verticalScrollBarFactory() : ScrollBar {
            var scrollbar:ScrollBar = new ScrollBar();
            scrollbar.direction = Direction.VERTICAL;
            scrollbar.thumbFactory = function() : Button {
                var button : Button = new Button();
                var sprite : Sprite = new Sprite();
                var back : Quad = new Quad(8, 25, 0xffffff);
                back.alpha = 0;
                var quad : Quad = new Quad(4, 25, 0xC1C3C2);
                quad.x = -2;
                sprite.addChild(back);
                sprite.addChild(quad);
                button.defaultSkin = sprite;
                return button;
            };
            return scrollbar;
        }

        public function set brands(value:Array):void{
            _brands = value;
            var car:Car;
            var carAppMode:String;
            var currAppMode:String;
            var i:int;
            //bodyTypeGroups = {};
            typeToggleGroup.removeEventListener(Event.CHANGE, typeGroupChangeHandler);
            typeToggleGroup.removeAllItems();
            bodyTypesList = [];

            if(_brands[0].name != "ALL"){
                var allBrand:Brand = new Brand();
                allBrand.name = "ALL";
                allBrand.imageURL = "";
                allBrand.cars = [];
                _brands.unshift(allBrand);
            }

            _brandsList.dataProvider = new ListCollection(_brands);
            for(i = 0; i < _brands.length; i++){
                var brand:Brand = _brands[i] as Brand;
                if(brand.cars){
                    for(var j:int = 0; j < brand.cars.length; j++){
                        if(brand.limitedOption){
                            continue;
                        }
                        car = brand.cars[j];
                        carAppMode = AppMode.getModeForCar(car);
                        currAppMode = AppMode.self.mode;
                        if(!car.bodyTypeList || !car.bodyTypeList.length || carAppMode != currAppMode){
                            continue;
                        }
                        if(allBrand){
                            allBrand.addCar(car);
                        }
                    }
                }
            }
            DisplayObjectUtil.removeChildren(_typeMenu);
            bodyTypesList = bodyTypeLabels[AppMode.self.mode];
            typeToggleGroup.addItem(ButtonFactory.carChooserTopButton("ALL", "all"));
            _typeMenu.addChild(typeToggleGroup.getItemAt(typeToggleGroup.numItems - 1) as ToggleButton);
            if(bodyTypesList){
                for(i = 0; i < bodyTypesList.length; i++){
                    typeToggleGroup.addItem(ButtonFactory.carChooserTopButton(bodyTypesList[i].name, bodyTypesList[i].value));
                    _typeMenu.addChild(typeToggleGroup.getItemAt(typeToggleGroup.numItems - 1) as ToggleButton);
                }
                for(i = 0; i < _brandsList.dataProvider.length; i++){
                    if(Brand(_brandsList.dataProvider.getItemAt(i)).lastAdded){
                        _brandsList.selectedIndex = i;
                        break;
                    }
                }
                typeToggleGroup.addEventListener(Event.CHANGE, typeGroupChangeHandler);
            }
        }

        private function get filteredCarsList():Array{
            var bodyTypeBtn:ToggleButton;
            var bodyType:String;
            if(typeToggleGroup && typeToggleGroup.numItems){
                if(typeToggleGroup.selectedItem){
                    bodyTypeBtn = typeToggleGroup.selectedItem as ToggleButton;
                }else{
                    bodyTypeBtn = typeToggleGroup.getItemAt(0) as ToggleButton;
                }
                bodyType = bodyTypeBtn.name;
            }else{
                bodyType = "all";
            }

            var selectedBrand:Brand = (_brandsList.selectedItem || _brands[0]) as Brand;
            var result:Array = [];
            var resultOrder:Array;
            var allCars:Array = Brand(_brands[0]).cars.concat();
            var i:int;
            var k:int;
            if(Brand(_brands[_brands.length - 1]).limitedOption){
                allCars = allCars.concat(Brand(_brands[_brands.length - 1]).cars);
            }

            if(_car_filter && _car_filter.length) {
                var filter1:String = _car_filter.replace("-", " ");
                var filter2:String = _car_filter.replace("-", "");
                var searchTerms:Array = ArrayUtil.uniqueConcat(filter1.split(" "), filter2.split(" "));
                var searchRegexps:Array = [];

                for(k = searchTerms.length - 1; k >= 0; k--){
                    if(!searchTerms[k] || !searchTerms[k].length){
                        searchTerms.removeAt(k);
                        continue;
                    }
                    searchRegexps.unshift(new RegExp('(^|\\s)' + searchTerms[k].toLowerCase() + '.*', 'gmi'));
                }
            }

            for (i = 0; i < allCars.length; i++) {
                var car:Car = allCars[i] as Car;
                if (bodyType != "all" && !(car.bodyTypeList && car.bodyTypeList.indexOf(bodyType) != -1)) {
                    continue;
                }

                if (!car.id) {
                    continue;
                }

                if(searchTerms && searchTerms.length) {
                    var matchCount:int = 0;
                    for (k = 0; k < searchTerms.length; k++) {
                        var srcFound:Boolean = false;
                        var searchIndex:int = -1;
                        var priority:int = -1;
                        var searchText:String = searchTerms[k];
                        var searchReg:RegExp = searchRegexps[k];
                        var carName:String = car.name;
                        var carModel:String = car.model;


                        var carNameStr:String;
                        if (carName) {
                            carNameStr = carName.replace('-', ' ').toLowerCase();
                            searchIndex = carNameStr.search(searchReg);

                            srcFound = (searchIndex != -1);
                            if (srcFound) {
                                priority = 0;
                            } else {
                                carNameStr = carName.replace('-', '').toLowerCase();
                                searchIndex = carNameStr.search(searchReg);
                                srcFound = (searchIndex != -1);
                            }
                        }


                        var carModelStr:String;
                        if (!srcFound && carModel) {
                            carModelStr = carModel.replace('-', ' ').toLowerCase();

                            searchIndex = carModelStr.search(searchReg);

                            srcFound = (searchIndex != -1);
                            if (srcFound) {
                                priority = 0;
                            } else {
                                carModelStr = carModel.replace('-', '').toLowerCase();
                                searchIndex = carModelStr.search(searchReg);
                                srcFound = (searchIndex != -1);
                            }
                        }


                        if (!srcFound) {
                            var carYear:int = parseInt(searchText);
                            if (carYear == car.year) {
                                searchIndex = 0;
                                priority = 2;
                            } else if (car.startYear && car.endYear && carYear >= car.startYear && carYear <= car.endYear) {
                                searchIndex = carYear - car.startYear;
                                priority = 3;
                            } else if (searchText.length) {
                                searchIndex = car.year.toString().indexOf(searchText);
                                if (searchIndex == -1 && car.startYear) {
                                    searchIndex = car.startYear.toString().indexOf(searchText);
                                }
                                if (searchIndex == -1 && car.endYear) {
                                    searchIndex = car.endYear.toString().indexOf(searchText);
                                }
                                priority = 4;
                            } else {
                                searchIndex = -1;
                            }
                            srcFound = (searchIndex != -1);
                        }
                        if (!srcFound) {
                            break;
                        }
                        matchCount++;
                    }
                }
                resultOrder ||= [];
                if (searchTerms && searchTerms.length) {
                    if(matchCount == searchTerms.length){
                        resultOrder.push({priority: priority, index: searchIndex, year: car.year, car: car});
                    }
                }else if(result.indexOf(car) == -1 && selectedBrand.cars.indexOf(car) != -1){
                    result.push(car);
                    if (!car.year && car.startYear) {
                        car.year = car.startYear;
                    }
                }
            }

            if(resultOrder && resultOrder.length){
                resultOrder.sortOn(["priority", "index", "year"], [Array.NUMERIC, Array.NUMERIC, Array.NUMERIC|Array.DESCENDING]);
                result = [];
                for(var j:int = 0; j < resultOrder.length; j++){
                    if(result.indexOf(resultOrder[j].car) == -1){
                        if(selectedBrand.limitedOption){
                            result.push(resultOrder[j].car);
                        }else if(selectedBrand.cars.indexOf(resultOrder[j].car) != -1 || Car(resultOrder[j].car).limitedOptions){
                            result.push(resultOrder[j].car);
                        }
                    }
                }
            }else if(!selectedBrand.lastAdded){
                result.sortOn("year", Array.NUMERIC | Array.DESCENDING);
            }
            return result;
        }

        private function typeGroupChangeHandler(event:Event):void {
            var bodyTypeBtn:ToggleButton;
            var bodyType:String;
            var i:int;
            var j:int;
            if(typeToggleGroup && typeToggleGroup.numItems){
                if(typeToggleGroup.selectedItem){
                    bodyTypeBtn = typeToggleGroup.selectedItem as ToggleButton;
                }else{
                    bodyTypeBtn = typeToggleGroup.getItemAt(0) as ToggleButton;
                }
                bodyType = bodyTypeBtn.name;
            }else{
                bodyType = "all";
            }
            var selectedBrand:Brand = _brandsList.selectedItem as Brand;
            var brandsArr:Array;
            if(bodyType == "all"){
                _brandsList.removeEventListener(Event.CHANGE, brandsListChangeHandler);
                _brandsList.dataProvider = new ListCollection(_brands);
                _brandsList.selectedItem = selectedBrand;
                _brandsList.addEventListener(Event.CHANGE, brandsListChangeHandler);
            }else{
                brandsArr = _brands.concat();
                for(i = brandsArr.length - 1; i > 0; i--){
                    var brand:Brand = brandsArr[i] as Brand;
                    for(j = 0; j < brand.cars.length; j++){
                        var car:Car = brand.cars[j];
                        if(car.bodyTypeList && car.bodyTypeList.indexOf(bodyType) != -1){
                            break;
                        }
                    }
                    if(j == brand.cars.length){
                        brandsArr.removeAt(i);
                    }
                }
                _brandsList.removeEventListener(Event.CHANGE, brandsListChangeHandler);
                _brandsList.dataProvider = new ListCollection(brandsArr);
                if(_brandsList.dataProvider.contains(selectedBrand)){
                    _brandsList.selectedItem = selectedBrand;
                }else{
                    _brandsList.selectedIndex = 0;
                }
                _brandsList.addEventListener(Event.CHANGE, brandsListChangeHandler);
            }
            brandsListChangeHandler(null);
            if(_car_filter && _car_filter.length){
                _brandsList.removeEventListener(Event.CHANGE, brandsListChangeHandler);
                brandsArr = [];
                for(j = 0; j < _brands.length; j++){
                    for(i = 0; i < _filteredCars.length; i++){
                        if(Brand(_brands[j]).cars.indexOf(_filteredCars[i]) != -1){
                            brandsArr.push(_brands[j]);
                            break;
                        }
                    }
                }
                _brandsList.dataProvider = new ListCollection(brandsArr);
                if(_brandsList.dataProvider.contains(selectedBrand)){
                    _brandsList.selectedItem = selectedBrand;
                }else{
                    _brandsList.selectedIndex = 0;
                }
                selectedBrand = _brandsList.selectedItem as Brand;
                var fCars:Array = [];
                for(i = 0; i < _filteredCars.length; i++){
                    if(selectedBrand.cars.indexOf(_filteredCars[i]) != -1){
                        fCars.push(_filteredCars[i]);
                    }
                }
                _brandsList.addEventListener(Event.CHANGE, brandsListChangeHandler);
                var showBrand : Boolean = selectedBrand && (selectedBrand.lastAdded || selectedBrand.limitedOption || selectedBrand.name == "ALL");
                var collection : ListCollection = new ListCollection(fCars);
                _carsList.showBrandName = showBrand;
                _carsList.dataProvider = collection;
                _carsList.data = {
                    showBrand : showBrand
                }
            }
        }

        private function closeButtonTriggeredHandler(event:Event):void {
            close();
        }

        public function open():void{
            if(_searchButton){
                _searchButton.removeEventListener(Event.CHANGE, searchChangeHandler);
                _searchButton.text = "";
                _car_filter = "";
                _searchButton.addEventListener(Event.CHANGE, searchChangeHandler);
            }

            if(typeToggleGroup && typeToggleGroup.numItems){
                typeToggleGroup.removeEventListener(Event.CHANGE, typeGroupChangeHandler);
                typeToggleGroup.selectedIndex = 0;
                typeToggleGroup.addEventListener(Event.CHANGE, typeGroupChangeHandler);
            }

            if(_brandsList && _brandsList.dataProvider && _brandsList.dataProvider.length){
                _brandsList.removeEventListener(Event.CHANGE, brandsListChangeHandler);
                _brandsList.dataProvider = new ListCollection(_brands);
                for(var i:int = 0; i < _brandsList.dataProvider.length; i++){
                    if(Brand(_brandsList.dataProvider.getItemAt(i)).lastAdded){
                        _brandsList.selectedIndex = i;
                        break;
                    }
                }
                _brandsList.addEventListener(Event.CHANGE, brandsListChangeHandler);

                brandsListChangeHandler(null);
            }

            if(_carsList && _carsList.dataProvider){
                //_carsList.dataProvider.updateAll();
                _carsList.validate();
            }

            dispatchEventWith(Event.OPEN);
            if(Starling.juggler.containsTweens(this)){
                Starling.juggler.removeTweens(this);
            }
            alpha = 0;
            visible = true;
            Starling.juggler.tween(this, 0.15, {alpha: 1});
        }

        public function close():void{
            if(Starling.juggler.containsTweens(this)){
                Starling.juggler.removeTweens(this);
            }
            Starling.juggler.tween(this, 0.15, {alpha: 0, onComplete: function():void{
                    visible = false;
                    dispatchEventWith(Event.CLOSE);
                }});
        }

        private function brandsListItemRendererFactory() : IListItemRenderer {
            var renderer : BrandItemRenderer = new BrandItemRenderer();
            renderer.setSize(_brandsList.width, 66);
            return renderer;
        }

        override public function validate():void {
            super .validate();
            if(_carsList && _carsList.dataProvider){
                _carsList.dataProvider.updateAll();
                _carsList.validate();
            }
            if(_brandsList && _brandsList.dataProvider){
                _brandsList.dataProvider.updateAll();
                _brandsList.validate();
            }
        }

        override protected function draw():void{
            super .draw();
            var margin:Number = 5;
            _brandsList.width = 105;
            _brandsList.height = actualHeight - BannerStackedScreen.BANNER_SIZE - 2 * margin;
            _brandsList.x = margin + _sideMargin;
            _brandsList.y = BannerStackedScreen.BANNER_SIZE;

            brandListTopBorder.width = _brandsList.width;
            brandListTopBorder.x = _brandsList.x;
            brandListTopBorder.y = _brandsList.y;

            brandListBottomBorder.width = _brandsList.width;
            brandListBottomBorder.x = _brandsList.x;
            brandListBottomBorder.y = _brandsList.y + _brandsList.height - brandListBottomBorder.height;

            _carsList.width = actualWidth - _brandsList.width - margin - 2 * _sideMargin;
            _carsList.height = _brandsList.height;
            _carsList.x = _brandsList.x + _brandsList.width + margin;
            _carsList.y = BannerStackedScreen.BANNER_SIZE;

            carsListTopBorder.width = _carsList.width - 17;
            carsListTopBorder.x = _carsList.x;
            carsListTopBorder.y = _carsList.y;

            _topButtonsMenu.validate();
            _typeMenu.width = actualWidth - _topButtonsMenu.width - 6 * margin - 2 * _sideMargin;
            _typeMenu.x = 2 * margin + _sideMargin;
            _topButtonsMenu.x = _typeMenu.x + _typeMenu.width + 2 * margin;

            _messageLabel.y = (actualHeight + _topButtonsMenu.height - _messageLabel.height) / 2;
        }
    }
}
