package com.despark.tuning3d.view.components.challenges.modals {
    import com.despark.tuning3d.ApplicationFacade;
    import com.despark.tuning3d.model.brands.BrandsParser;
    import com.despark.tuning3d.model.challenges.ChallengeEvent;
    import com.despark.tuning3d.model.challenges.ChallengesProxy;
    import com.despark.tuning3d.model.core.BannerScreen;
    import com.despark.tuning3d.model.friend.Friend;
    import com.despark.tuning3d.model.sounds.SoundManager;
    import com.despark.tuning3d.model.tunings.Tuning;
    import com.despark.tuning3d.model.tunings.TuningsProxy;
    import com.despark.tuning3d.model.users.User;
    import com.despark.tuning3d.model.users.UsersProxy;
    import com.despark.tuning3d.view.components.challenges.TuningChallengeType;
    import com.despark.tuning3d.view.components.challenges.controls.ChallengesAlert;
    import com.despark.tuning3d.view.components.challenges.controls.ChallengeTuningItemRenderer;
    import com.despark.tuning3d.view.components.challenges.controls.ChallengeUserItemRenderer;
    import com.despark.tuning3d.view.components.challenges.controls.SearchBox;
    import com.despark.tuning3d.view.components.challenges.controls.SearchResultList;
    import com.despark.tuning3d.view.components.core.AlertView;
    import com.despark.tuning3d.view.components.core.BannerStackedScreen;
    import com.despark.tuning3d.view.components.core.ButtonFactory;
    import com.despark.tuning3d.view.components.core.ImageLoaderWithStates;
    import com.despark.tuning3d.view.components.core.LabelFactory;
    import com.despark.tuning3d.view.components.core.PopUp;
    import com.despark.tuning3d.view.components.instructions.SimpleImageProvider;
    import com.despark.tuning3d.view.components.timeline.components.UserCircularAvatar;
    import com.distriqt.AdsManager;
    import com.utils.FontSelector;
    import com.utils.ImageUtils;
    import com.utils.ObjectUtils;
    import com.utils.TextureUtil;
import com.utils.ObjectUtils;
import com.utils.TextureUtil;
    import com.utils.Tracker;

    import feathers.controls.Button;
    import feathers.controls.Label;
    import feathers.controls.LayoutGroup;
    import feathers.controls.ToggleButton;
    import feathers.controls.renderers.IListItemRenderer;
    import feathers.controls.text.TextFieldTextRenderer;
    import feathers.core.FeathersControl;
    import feathers.core.ITextRenderer;
    import feathers.core.ToggleGroup;
    import feathers.data.ListCollection;
    import feathers.layout.AnchorLayout;
    import feathers.layout.HorizontalLayout;
    import feathers.layout.RelativePosition;
    import feathers.layout.VerticalAlign;
    import feathers.controls.Button;
import feathers.controls.Label;
import feathers.controls.LayoutGroup;
import feathers.controls.Radio;
import feathers.controls.ToggleButton;
import feathers.controls.renderers.IListItemRenderer;
import feathers.controls.text.TextFieldTextRenderer;
import feathers.core.ITextRenderer;
import feathers.core.ToggleGroup;
import feathers.data.ListCollection;
import feathers.data.ListCollection;
import feathers.layout.AnchorLayout;
import feathers.layout.HorizontalLayout;
import feathers.layout.RelativePosition;
import feathers.layout.VerticalAlign;

    import flash.geom.Rectangle;
    import flash.text.TextFormat;
    import flash.text.TextFormatAlign;
    import flash.utils.setTimeout;

    import starling.animation.Transitions;
    import starling.core.Starling;
    import starling.display.Image;
    import starling.display.Quad;
    import starling.events.Event;
    import starling.events.Touch;
    import starling.events.TouchEvent;
    import starling.events.TouchPhase;
    import starling.utils.Align;
    import starling.utils.ScaleMode;

    public class StartChallengePopup extends PopUp {
    private static var _instance:StartChallengePopup;
    private var _challengeLogo:Image;
    private var _vsLogo:Image;
    private var _container:LayoutGroup;
    //
    private var _confirmButton:Button;
    private var _cancelButton:Button;
    private var _data:Object;
    private var _avatar : UserCircularAvatar;
    private var _randomChallengeSelect:ToggleButton;
    private var _rulesButton:Button;
    private var _rulesBackButton:Button;

    private var _selectedCar:ImageLoaderWithStates;
    private var _senderCar:ImageLoaderWithStates;
    private var _selectedCarImage:Image;
    private var _senderCarImage:Image;

    private var _challengeTypeGroup:ToggleGroup;
    private var _challengeTypeLayout:LayoutGroup;
    private var _challengeAllButton:ToggleButton;
    private var _challengeSameCarButton:ToggleButton;

    private var _recipientLabel:Button;
    private var _senderLabel:Button;
    private var _senderUsernameLabel:FeathersControl;
    private var _challengesList:Object = {};
    private var _currentUserTuningList:Array = [];
    private var _currentUserFriendList:Array = [];
    private var _tuningList:SearchBox;
    private var _userList:SearchBox;
    private var _friendsRequestedIndex:int;

    public static const INPUT_SIZE:int = 10;

    private var _tuning:Tuning;
    private var _user:User;
    private var _currentUser:User;
    private var _isInvitation:Boolean;
    private var _showBannerAfterExit:Boolean;
    private var _bannerScreen:String;
    public const tuningLimit:int = 100;

    private var _carY:Number = -10;
    private var _tuningChallengeType:String;
    private var _emptyMessageLabel:Label;
    private var _challengeCoinsLabel:Label;

    private var userBorder:Quad;
    //
    private var _randomUserImage:Image;
    private var _defaultUserImage:Image;
    private var _defaultTuningImage:Image;
    private var _rewardedVotesImage:Image;
    private var _rulesImage:Image;
    public function StartChallengePopup(popupData:Object = null) {
        super();
        var usersProxy : UsersProxy = ApplicationFacade.getInstance().retrieveProxy(UsersProxy.NAME) as UsersProxy;
        _currentUser = usersProxy.currentUser;
        _data = popupData;
        _showBannerAfterExit = _data.hasOwnProperty("showBannerAfterExit") && _data.showBannerAfterExit;
        _bannerScreen = (popupData && popupData.hasOwnProperty("bannerScreen"))?popupData["bannerScreen"]:BannerScreen.BANNER_SCREEN;
        usersProxy.loadCurrentUser(updateCoinCount);
    }

    public function get tuningSkip():int{
        if(!_tuningList){
            return 0;
        }
        return _tuningList.length;
    }

    override protected function initialize():void {
        super.initialize();
        setSizeInternal(stage.stageWidth, stage.stageHeight,false);
        _carY = actualHeight/5 + 20;
        _isInvitation = _data.hasOwnProperty("isInvitation") && _data.isInvitation;

        _container ||= new LayoutGroup();
        background.color = 0xFFFFFF;
        background.alpha = 1;
        contentBackgroundImage.visible = false;

        var logoId:String = _data.isInvitation?"challenges_accept_logo":"challenges_start_accept_bg";
        _challengeLogo ||= new Image(ButtonFactory.assetManager.getTexture(logoId));
        _container.layout = new AnchorLayout();
        addChild(_container);
        _challengeLogo.scale = ButtonFactory.assetManager.scaleFactor / 2;
        _container.addChild(_challengeLogo);

        _vsLogo ||= new Image(ButtonFactory.assetManager.getTexture("vs_large"));
        _vsLogo.scale = 1.5 * ButtonFactory.assetManager.scaleFactor / 2;
        _container.addChild(_vsLogo);

        _recipientLabel = getLabel();
        if(_isInvitation) {
            _recipientLabel.addEventListener(Event.TRIGGERED, selectTuningHandler);
            _tuningChallengeType = ObjectUtils.getProperty(_data, 'challengeData.challengeType')
        }else{
            _recipientLabel.label = "CHOOSE OPPONENT";
            _recipientLabel.addEventListener(Event.TRIGGERED, selectUserHandler);
        }
        _defaultUserImage = new Image(ButtonFactory.assetManager.getTexture("challenge_users_default"));
        _defaultUserImage.width = _defaultUserImage.height = 84;

        _defaultTuningImage = new Image(ButtonFactory.assetManager.getTexture("challenge_tuning_default"));
        _defaultTuningImage.scale = ButtonFactory.assetManager.scaleFactor / 2;

        _rewardedVotesImage = new Image(ButtonFactory.assetManager.getTexture("rewarded_votes_img"));
        _rewardedVotesImage.scale = ButtonFactory.assetManager.scaleFactor / 2;
        _rewardedVotesImage.addEventListener(TouchEvent.TOUCH, rewardsTriggeredHandler);

        _senderLabel = getLabel(_isInvitation);
        if(!_isInvitation) {
            _senderLabel.addEventListener(Event.TRIGGERED, selectTuningHandler);
        }

        _rulesButton = new Button();
        _rulesButton.labelFactory = LabelFactory.startChallengeRulesLabel;
        _rulesButton.label = "Rules";
        _rulesButton.addEventListener(Event.TRIGGERED, ruleButtonTriggeredHandler);

        _rulesBackButton = ButtonFactory.challengeAcceptButton("Back", "active_label_bg", 0x313131);
        _rulesBackButton.addEventListener(Event.TRIGGERED, ruleButtonTriggeredHandler);

        addChild(_senderLabel);
        addChild(_recipientLabel);
        addChild(_defaultUserImage);
        addChild(_defaultTuningImage);
        addChild(_rewardedVotesImage);
        addChild(_rulesButton);
        _rulesButton.validate();
        if(_isInvitation && _data.sender.user){
            setSelectedUser(_data.sender.user as User);
        }else if(_data.recipient.user) {
            if(_currentUser && _data.recipient.user && _currentUser.id != User(_data.recipient.user).id) {
                setSelectedUser(_data.recipient.user as User);
            }
        }
        //
        var acceptLabel:String = "Invite";
        var challengeData:Object = {selectTuning: true};
        if(_data && _data.hasOwnProperty("isInvitation") && _data.isInvitation){
            acceptLabel = "Accept";
            challengeData.selectTuning = true;
            _senderCar = new ImageLoaderWithStates();
            _senderCar.scaleMode = ScaleMode.NONE;
            var simpleImageProvider : SimpleImageProvider = new SimpleImageProvider();
            simpleImageProvider.urlForDownloading = _data.sender.tuning.customSnapshots[0];
            _senderCar.persistentImageProvider = simpleImageProvider;
            _senderCar.completeHandler = function():void{
                _senderCarImage = ImageUtils.getCarImage(_senderCar.image);
                if(_senderCarImage) {
                    _senderCarImage.width = _senderLabel.width - 10;
                    _senderCarImage.height = _senderCarImage.width * _senderCarImage.texture.nativeHeight / _senderCarImage.texture.nativeWidth;
                    _senderCarImage.x = _senderLabel.x + (_senderLabel.width - _senderCarImage.width) / 2;
                    _senderCarImage.y = _senderLabel.y + 10 - _senderCarImage.height - (_senderCarImage.height < 125 ? (125 - _senderCarImage.height) / 2 : 0);
                    _container.addChild(_senderCarImage);
                }

                _senderCar.removeFromParent(true);
                _senderCar = null;
            };
            _senderCar.errorHandler = function():void{

            };
            _senderCar.visible = false;
            _container.addChild(_senderCar);
            if(!_data.sender.tuning.car && BrandsParser.allCarsList[_data.sender.tuning.carObj._id]){
                _data.sender.tuning.car = BrandsParser.allCarsList[_data.sender.tuning.carObj._id];
            }

            if(_data.sender.tuning.car){
                _senderLabel.label = _data.sender.tuning.car.displayName;
            }else{
                _senderLabel.label = _data.sender.tuning.name;
            }
        }else{
            if(_data) {
                challengeData.selectTuning = !(_data.sender.tuning == null);
            }else{
                challengeData.selectTuning = false;
            }

            Tracker.trackEvent("Start Challenge Popup", "open");
        }

        createChallengeTypes();

        _confirmButton = ButtonFactory.challengeAcceptButton(acceptLabel);
        _cancelButton = ButtonFactory.challengeDeclineButton("Decline");
        _container.addChild(_confirmButton);
        _container.addChild(_cancelButton);
        _cancelButton.addEventListener(Event.TRIGGERED, onCancelTriggered);
        if(_data && _data.hasOwnProperty("isInvitation") && _data.isInvitation){
            _confirmButton.addEventListener(Event.TRIGGERED, acceptButtonHandler);
        }else {
            _confirmButton.addEventListener(Event.TRIGGERED, inviteButtonHandler);
            _cancelButton.label = "Cancel";
        }
        _tuningList = new SearchBox(logoId, "timeline_car", "Select Car");
        _tuningList.searchResult.addEventListener(Event.CHANGE, tuningSelectHandler);
        _tuningList.searchResult.itemRendererFactory = function() : IListItemRenderer {
            var renderer : ChallengeTuningItemRenderer = new ChallengeTuningItemRenderer();
            var item_w:Number=(_tuningList.searchResult.width/3);
            var item_h:Number=(_tuningList.searchResult.height/3);
            renderer.setSize(item_w, item_h);
            return renderer;
        };
        _tuningList.customSearchProvider = function(searchTerm:String):void{
            dispatchEvent(new Event(ChallengeEvent.SEARCH_TUNINGS, false, {searchTerm:searchTerm, skip:0, completeHandler:function (tuningsList:Array):void {
                    var tunings:Array = [];
                    for(var i:int = 0; i < tuningsList.length; i++){
                        var tng:Tuning = TuningsProxy.parseTuning(tuningsList[i], true);
                        if(_tuningChallengeType && _tuningChallengeType == TuningChallengeType.SAME_CAR){
                            if(tng.car.id == _data.sender.tuning.carObj._id && !_challengesList.hasOwnProperty(tng.id)){
                                tunings.push(tng);
                            }
                        }else if(!_challengesList.hasOwnProperty(tng.id)) {
                            tunings.push(tng);
                        }
                    }
                    _tuningList.searchResult.dataProvider = new ListCollection(tunings);
                }
            }));
        };

        _tuningList.searchResult.addEventListener(SearchResultList.END_REACHED, tuningListEndReachedHandler);
        _tuningList.setSize(actualWidth, actualHeight);
        addChild(_tuningList);

        _userList = new SearchBox(logoId, "timeline_my_activities_icon", "Select Opponent");
        userBorder = new Quad(1,1,0xC2C2C2);
        userBorder.width = actualWidth;
        _userList.addChild(userBorder);
        _userList.searchResult.addEventListener(Event.CHANGE, userSelectHandler);
        _userList.setSize(actualWidth, actualHeight);
        ChallengesProxy.USER_REQUEST_COUNT = 2*Math.ceil(_userList.width/80)*Math.ceil(_userList.height/60);
        _userList.searchResult.itemRendererFactory = function() : IListItemRenderer {
            var renderer : ChallengeUserItemRenderer = new ChallengeUserItemRenderer();
            var item_w:Number = 80;
            var item_h:Number = 60;
            renderer.setSize(item_w, item_h);
            return renderer;
        };
        addChild(_userList);
        _friendsRequestedIndex = 0;
        _currentUserFriendList = [];
        _userList.searchResult.addEventListener(Event.SCROLL, onUserListScroll);

        _userList.close(false);
        _tuningList.close(false);
        _userList.customSearchProvider = function(searchTerm:String):void{
            dispatchEvent(new Event(ChallengeEvent.SEARCH_USERS, false, {searchTerm:searchTerm, skip:0, completeHandler:function (friendList:Array):void {
                    for(var i:int = friendList.length-1; i >= 0; i--){
                        var friend:Friend = friendList[i];
                        if(friend.user.id == _currentUser.id){
                            friendList.removeAt(i);
                        }
                    }
                    _userList.searchResult.dataProvider = new ListCollection(friendList);
                }
            }));
        };

        var closeIcon:Image = new Image(ButtonFactory.assetManager.getTexture("details_close"));
        closeIcon.scale = ButtonFactory.assetManager.scaleFactor/2;
        closeButton.width = closeIcon.width;
        closeButton.height = closeIcon.height;
        closeButton.defaultIcon = closeIcon;
        addChild(closeButton);

        _emptyMessageLabel = new Label();
        _emptyMessageLabel.wordWrap = true;
        _emptyMessageLabel.textRendererFactory = function () : ITextRenderer {
            var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
            textRenderer.textFormat = new TextFormat(FontSelector.getMonserratSemiBold(), 11, 0x424242);
            textRenderer.textFormat.italic = false;
            textRenderer.textFormat.bold = false;
            textRenderer.embedFonts = true;
            textRenderer.textFormat.align = TextFormatAlign.CENTER;
            return textRenderer;
        };

        _challengeCoinsLabel = new Label();
        _challengeCoinsLabel.width = 30;
        _challengeCoinsLabel.touchable = false;
        _challengeCoinsLabel.textRendererFactory = function () : ITextRenderer {
            var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
            textRenderer.textFormat = new TextFormat(FontSelector.getMonserratSemiBold(), 14, 0xC10000);
            textRenderer.textFormat.italic = false;
            textRenderer.textFormat.bold = false;
            textRenderer.textFormat.align = TextFormatAlign.CENTER;
            textRenderer.embedFonts = true;
            return textRenderer;
        };
        addChild(_challengeCoinsLabel);

        dispatchEvent(new Event(ChallengeEvent.LOAD_USER_CHALLENGES, false, challengeData));
        dispatchEvent(new Event(ChallengeEvent.LOAD_USER_FRIENDS, false, {skip:0}));
        //

    }

        private function rewardsTriggeredHandler(event:TouchEvent):void {
            var touch:Touch = event.getTouch(_rewardedVotesImage, TouchPhase.ENDED)
            if(touch){
                ruleButtonTriggeredHandler(null);
            }
        }

        private function updateCoinCount(obj:Object):void{
            if(obj is String){
                obj = JSON.parse(obj as String);
            }
            if(obj && obj.hasOwnProperty("challengeCoins")){
                _currentUser.challengeCoins = obj.challengeCoins;
                if(_challengeCoinsLabel){
                    _challengeCoinsLabel.text = _currentUser.challengeCoins.toString();
                }
            }
        }

    private function createChallengeTypes():void{
        _challengeTypeGroup = new ToggleGroup();
        _challengeTypeLayout = new LayoutGroup();
        var challengeLayout:HorizontalLayout = new HorizontalLayout();
        challengeLayout.gap = 0;
        _challengeTypeLayout.layout = challengeLayout;

        _challengeAllButton = ButtonFactory.challengeRadioButton('All Cars');
        _challengeAllButton.name = TuningChallengeType.ALL;
        _challengeAllButton.width = 60;

        _challengeSameCarButton = ButtonFactory.challengeRadioButton('Same Car', Align.RIGHT);
        _challengeSameCarButton.name = TuningChallengeType.SAME_CAR;
        _challengeSameCarButton.width = 60;

        _challengeTypeGroup.addItem(_challengeAllButton);
        _challengeTypeGroup.addItem(_challengeSameCarButton);
        _challengeTypeGroup.addEventListener(Event.CHANGE, challengeTypeChangeHandler);
        _challengeTypeLayout.addChild(_challengeAllButton);
        _challengeTypeLayout.addChild(_challengeSameCarButton);
        _container.addChild(_challengeTypeLayout);
        _challengeTypeLayout.validate();
        if(_isInvitation && _tuningChallengeType){
            for(var i:int = 0; i < _challengeTypeGroup.numItems; i++){
                if(_challengeTypeGroup.getItemAt(i).name == _tuningChallengeType){
                    _challengeTypeGroup.selectedItem = _challengeTypeGroup.getItemAt(i);
                    break;
                }
            }
            _challengeTypeLayout.isEnabled = false;
        }
    }

    private function challengeTypeChangeHandler(event:Event):void {
        if(_challengeTypeGroup.selectedItem){
            SoundManager.playSound(SoundManager.SELECT_PART);
        }
    }

    private function tuningListEndReachedHandler(event:Event):void {
        dispatchEvent(new Event(ChallengeEvent.LOAD_USER_ALLOWED_TUNINGS));
    }

    private function inviteButtonHandler(event:Event):void {
        var challengeType:String = ((_challengeTypeGroup && _challengeTypeGroup.selectedItem)?_challengeTypeGroup.selectedItem.name:'all');
        var eventData:Object = {};
        if(_tuning){
            var userId:String;
            if(_tuning.userObj is User){
                userId = _tuning.userObj.id;
            }else if(_tuning.userObj is Object){
                userId = _tuning.userObj._id;
            }
            eventData = {
                userId: userId,
                carId: _tuning.car.id,
                carType: _tuning.car.type,
                challengeType: challengeType,
                tuningId:_tuning.id
            };
        }
        if(_randomChallengeSelect && _randomChallengeSelect.isSelected && _tuning){
            dispatchEvent(new Event(ChallengeEvent.RANDOM_CHALLENGE, false, eventData));
            // _confirmButton.alpha = _cancelButton.alpha = 0.6;
            //_confirmButton.isEnabled = _cancelButton.isEnabled = false;
            disablePopup();
            //setTimeout(closeButtonTriggeredHandler, 200, null);

            Tracker.trackEvent("Start Challenge Popup", "send challenge request");
        }else if(_tuning && _user){
            eventData.userId = _user.id;
            dispatchEvent(new Event(ChallengeEvent.INVITE_FOR_CHALLENGE, false, eventData));
            // _confirmButton.alpha = _cancelButton.alpha = 0.6;
            // _confirmButton.isEnabled = _cancelButton.isEnabled = false;
            disablePopup();
            //setTimeout(closeButtonTriggeredHandler, 200, null);

            Tracker.trackEvent("Start Challenge Popup", "send challenge request");
        }else{
            if(!_tuning){
                AlertView.show("Error: No tuning selected.");
            }else{
                AlertView.show("Error. No user selected.");
            }
        }
    }

    override protected function closeButtonTriggeredHandler(event:Event):void{
        super .closeButtonTriggeredHandler(event);
        SoundManager.playSound(SoundManager.SELECT_PART_BACK);
        if(_showBannerAfterExit){
            if(_bannerScreen == BannerScreen.BANNER_SCREEN){
                BannerStackedScreen.showAdBanner();
            }else if(_bannerScreen == BannerScreen.HOME_SCREEN){
                AdsManager.$.bannerShow(BannerScreen.HOME_SCREEN);
            }
        }
    }

    public function disablePopup():void{
        setPopupEnabled(false);
    }

     public function enablePopup():void{
         setPopupEnabled(true);
    }

        private function setPopupEnabled(value:Boolean):void{
            _senderLabel.touchable = _senderLabel.isEnabled = value;
            _recipientLabel.touchable = _recipientLabel.isEnabled = value;
            var objList:Array = [_senderLabel, _recipientLabel];
            if(_randomChallengeSelect){
                _randomChallengeSelect.isEnabled = value;
                objList.push(_randomChallengeSelect);
            }

            if(_challengeAllButton){
                _challengeAllButton.isEnabled = value;
                objList.push(_challengeAllButton);
            }

            if(_challengeSameCarButton){
                _challengeSameCarButton.isEnabled = value;
                objList.push(_challengeSameCarButton);
            }

            if(_confirmButton){
                _confirmButton.isEnabled = value;
                objList.push(_confirmButton);
            }

            if(_cancelButton){
                _cancelButton.isEnabled = value;
                objList.push(_cancelButton);
            }
            //
            var targetAlpha:Number = value?1: 0.8;
            for(var i:int = 0; i < objList.length; i++){
                Starling.juggler.tween(objList[i], 0.1, {alpha: targetAlpha});
            }
        }

    public function close():void{
        closeButtonTriggeredHandler(null);
    }

    private function acceptButtonHandler(event:Event):void {
        SoundManager.playSound(SoundManager.SELECT_PART);
        //closeButtonTriggeredHandler(null);
        dispatchEvent(new Event(ChallengeEvent.ACCEPT_CHALLENGE, false, {challengeId:_data.challengeId, tuningId:_tuning.id, notification:_data.notification}));
        Tracker.trackEvent("Start Challenge Popup", "accept challenge");
    }

    private function onUserListScroll(event:Event):void {
        if(_userList.isWaiting){
            return;
        }
        if(_userList.searchResult.verticalScrollPosition>=_userList.searchResult.maxVerticalScrollPosition) {
            if (_userList.searchField.text.length > 0) {
                if(!_userList.searchResult.dataProvider){
                    _userList.searchResult.dataProvider = new ListCollection([]);
                }
                var skip:int = _userList.searchResult.dataProvider.length;
                _userList.isWaiting = true;
                _userList.searchResult.loadingItems = 1;
                dispatchEvent(new Event(ChallengeEvent.SEARCH_USERS, false, {
                    searchTerm: _userList.searchField.text, skip: skip, completeHandler: function (friendList:Array):void {
                        for(var i:int = friendList.length-1; i >= 0; i--){
                            var friend:Friend = friendList[i];
                            if(friend.user.id == _currentUser.id){
                                friendList.removeAt(i);
                            }
                        }
                        _userList.searchResult.dataProvider.addAll(new ListCollection(friendList));
                        _userList.isWaiting = false;
                        _userList.searchResult.loadingItems = 0;
                    }
                }));
            }else if (_friendsRequestedIndex < _currentUserFriendList.length) {
                _userList.searchResult.loadingItems = 1;
                dispatchEvent(new Event(ChallengeEvent.LOAD_USER_FRIENDS, false, {skip: _currentUserFriendList.length}));
                _friendsRequestedIndex = _currentUserFriendList.length;
            }
        }
    }

    private function selectUserHandler(event:Event):void {
        if(_tuningList){
            _tuningList.close();
        }
        if(_userList) {
            _userList.setSize(actualWidth, actualHeight);
            _userList.toggle();
            if(_userList.isOpen){
                SoundManager.playSound(SoundManager.PART_MENU);
            }else{
                SoundManager.playSound(SoundManager.PART_MENU_CLOSE);
            }
        }
    }

    private function selectTuningHandler(event:Event):void {
        if(_userList && _userList.isOpen){
            _userList.close();
        }
        if(_tuningList) {
            _tuningList.setSize(actualWidth, actualHeight);
            _tuningList.toggle();
            if(_tuningList.isOpen){
                SoundManager.playSound(SoundManager.PART_MENU);
            }else{
                SoundManager.playSound(SoundManager.PART_MENU_CLOSE);
            }
        }

    }

    private function onCancelTriggered(event:Event):void {
        closeButtonTriggeredHandler(null);
        if(_isInvitation){
            dispatchEvent(new Event(ChallengeEvent.DECLINE_CHALLENGE, false, {challengeId:_data.challengeId, tuningId:null, notification:_data.notification}));
        }
    }

    override public function dispose():void {
        super.dispose();
        removeFromParent();
        if(_challengeLogo){
            _challengeLogo.removeFromParent(true);
            _challengeLogo = null;
            ButtonFactory.assetManager.removeTexture("challenges_start_accept_bg", true);
        }
        if(_vsLogo){
            _vsLogo.removeFromParent(true);
            _vsLogo = null;
        }

        if(_emptyMessageLabel){
            _emptyMessageLabel.removeFromParent(true);
            _emptyMessageLabel = null;
        }

        if(_challengeCoinsLabel){
            _challengeCoinsLabel.removeFromParent(true);
            _challengeCoinsLabel = null;
        }

        if(_challengeAllButton){
            _challengeAllButton.removeFromParent(true);
            _challengeAllButton = null;
        }

        if(_challengeSameCarButton){
            _challengeSameCarButton.removeFromParent(true);
            _challengeSameCarButton = null;
        }

        if(_challengeTypeLayout){
            _challengeTypeLayout.removeFromParent(true);
            _challengeTypeLayout = null;
        }

        if(_challengeTypeGroup){
            _challengeTypeGroup.removeAllItems();
            _challengeTypeGroup = null;
        }

        if(_container){
            _container.removeFromParent(true);
            _container = null;
        }

        if(_confirmButton){
            _confirmButton.removeFromParent(true);
            _confirmButton = null;
        }

        if(_cancelButton){
            _cancelButton.removeFromParent(true);
            _cancelButton = null;
        }

        if(_avatar){
            _avatar.removeFromParent(true);
            _avatar = null;
        }

        if(_randomChallengeSelect){
            _randomChallengeSelect.removeFromParent(true);
            _randomChallengeSelect = null;
        }

        if(_selectedCar){
            _selectedCar.removeFromParent(true);
            _selectedCar = null;
        }

        if(_senderCar){
            _senderCar.removeFromParent(true);
            _senderCar = null;
        }

        if(_selectedCarImage){
            _selectedCarImage.removeFromParent(true);
            _selectedCarImage = null;
        }

        if(_senderCarImage){
            _senderCarImage.removeFromParent(true);
            _senderCarImage = null;
        }

        if(_recipientLabel){
            _recipientLabel.removeFromParent(true);
            _recipientLabel = null;
        }

        if(_senderLabel){
            _senderLabel.removeFromParent(true);
            _senderLabel = null;
        }

        if(_senderUsernameLabel){
            _senderUsernameLabel.removeFromParent(true);
            _senderUsernameLabel = null;
        }

        if(_tuningList){
            _tuningList.removeFromParent(true);
            _tuningList = null;
        }

        if(_userList){
            _userList.removeFromParent(true);
            _userList = null;
        }
        if(userBorder){
            userBorder.removeFromParent(true);
            userBorder = null;
        }

        if(_randomUserImage){
            _randomUserImage.removeFromParent(true);
            _randomUserImage = null;
        }
        if(_defaultUserImage){
            _defaultUserImage.removeFromParent(true);
            _defaultUserImage = null;
        }

        if(_defaultTuningImage){
            _defaultTuningImage.removeFromParent(true);
            _defaultTuningImage = null;
        }

        if(_rewardedVotesImage){
            _rewardedVotesImage.removeFromParent(true);
            _rewardedVotesImage = null;
        }
        _instance = null;
    }

    public function appendChallenges(challenges:Array):void{
        _challengesList = {};
        for(var i:int = 0;  i < challenges.length; i++){
            _challengesList[challenges[i]] = true;
        }
    }

    public function setUserTunings(tunings:Array, selectTuning:Boolean = false, animate:Boolean = true):void{
        var latestFreeTuning:Tuning;
        _currentUserTuningList ||= [];
        var closeList:Boolean = (_currentUserTuningList.length == 0);
        for(var i:int = 0; i < tunings.length; i++){
            if(!_challengesList.hasOwnProperty(Tuning(tunings[i]).id) && Tuning(tunings[i]).car){
                if(_tuningChallengeType == TuningChallengeType.SAME_CAR){
                    if(Tuning(tunings[i]).car.id == _data.sender.tuning.carObj._id){
                        _currentUserTuningList.push(tunings[i]);
                    }
                }else{
                    _currentUserTuningList.push(tunings[i]);
                }
            }
        }
        _tuningList.searchResult.validate();

        if(selectTuning){
            if(_currentUserTuningList.length) {
                latestFreeTuning = _currentUserTuningList[0];
                if(!_isInvitation && _data.sender && _data.sender.tuning){
                    setSelectedTuning(_data.sender.tuning, animate);
                }else {
                    setSelectedTuning(latestFreeTuning, animate);
                }
                if(_emptyMessageLabel){
                    _emptyMessageLabel.removeFromParent();
                }
            }else{
                setSelectedTuning(null);
                if(_emptyMessageLabel && _tuningChallengeType){
                    _tuningList.addChild(_emptyMessageLabel);
                    _emptyMessageLabel.text = TuningChallengeType.getMessage(_tuningChallengeType);
                    _emptyMessageLabel.width = actualWidth / 2;
                    _emptyMessageLabel.height = NaN;
                    _emptyMessageLabel.validate();
                    _emptyMessageLabel.x = (_tuningList.width - _emptyMessageLabel.width) / 2;
                    _emptyMessageLabel.y = (_tuningList.height - _emptyMessageLabel.height) / 2;
                }
            }
        }else{
            setSelectedTuning(null, false, false, closeList);
        }
    }

    public function setUserFriends(friends:Array):void{
        _currentUserFriendList ||= [];
        _currentUserFriendList = _currentUserFriendList.concat(friends);
        var collection:ListCollection = (_userList.searchResult.dataProvider as ListCollection)||new ListCollection([]);
        collection.addAll(new ListCollection(friends));
        _userList.searchResult.dataProvider = collection;
        _userList.searchResult.loadingItems = 0;
    }

    private function setSelectedUser(user:User):void{
        _user = user;
        if(_avatar){
            _avatar.removeFromParent(true);
        }
        if(_defaultUserImage){
            _defaultUserImage.removeFromParent();
        }
        if(_randomUserImage){
            _randomUserImage.removeFromParent();
        }
        _avatar = new UserCircularAvatar(user, _isInvitation?40: 82);
        _container.addChild(_avatar);
        if(!_isInvitation){
            _recipientLabel.label = user.nameToShow;
        }else{
            _senderUsernameLabel = LabelFactory.createLabelMailUserName();
            addChild(_senderUsernameLabel);
            _senderUsernameLabel.width = NaN;
            _senderUsernameLabel["text"] = user.nameToShow;
            _senderUsernameLabel.validate();
        }
        if(_userList) {
            _userList.setSize(actualWidth, actualHeight);
            _userList.open();
        }
    }

    private function setSelectedTuning(tuning:Tuning, animate:Boolean = true, openList:Boolean = true, closeList:Boolean = true):void {
        if(tuning && _senderLabel){
            _tuning = tuning;
            var prevSelectedCar:Image = _selectedCarImage;
            if(_isInvitation){
                _recipientLabel.label = tuning.car?tuning.car.displayName:tuning.name;
            }else{
                _senderLabel.label = tuning.car?tuning.car.displayName:tuning.name;
            }
            _selectedCar = new ImageLoaderWithStates();
            var duration:Number = 0.15;
            var simpleImageProvider : SimpleImageProvider = new SimpleImageProvider();
            simpleImageProvider.urlForDownloading = tuning.customSnapshots[0];
            _selectedCar.persistentImageProvider = simpleImageProvider;
            _selectedCar.completeHandler = function():void{
                _selectedCarImage = ImageUtils.getCarImage(_selectedCar.image);
                if(_selectedCarImage) {
                    _selectedCarImage.color = 0xFF0000;
                    _selectedCarImage.alpha = 0;
                    _selectedCarImage.width = _recipientLabel.width - 10;
                    _selectedCarImage.height = _selectedCarImage.width * _selectedCarImage.texture.nativeHeight / _selectedCarImage.texture.nativeWidth;
                    _selectedCarImage.x = _recipientLabel.x + (_recipientLabel.width - _selectedCarImage.width) / 2;
                    _selectedCarImage.y = _recipientLabel.y + 10 - _selectedCarImage.height - (_selectedCarImage.height < 125 ? (125 - _selectedCarImage.height) / 2 : 0);
                    if (!_data.isInvitation) {
                        _selectedCarImage.x = _senderLabel.x + (_senderLabel.width - _selectedCarImage.width) / 2;
                    }
                    _container.addChild(_selectedCarImage);
                }
                if(_defaultTuningImage){
                    _defaultTuningImage.removeFromParent(true);
                    _defaultTuningImage = null;
                    Starling.juggler.tween(
                            _selectedCarImage,
                            duration,
                            {
                                alpha: 1,
                                transition: Transitions.LINEAR
                            });
                }else if(prevSelectedCar){
                    prevSelectedCar.texture.dispose();
                    prevSelectedCar.removeFromParent(true);
                    prevSelectedCar = null;
                    Starling.juggler.tween(
                            _selectedCarImage,
                            duration,
                            {
                                alpha: 1,
                                transition: Transitions.LINEAR
                            });
                }
                _selectedCar.removeFromParent();
            };
            _selectedCar.errorHandler = function():void{

            };
            _selectedCar.visible = false;
            _container.addChild(_selectedCar);
            _tuningList.close(animate);
        }
        if(_currentUserTuningList && _tuningList){
            if(!_tuningList.searchResult.dataProvider || _tuningList.searchResult.dataProvider.length==0){
                _tuningList.searchResult.dataProvider = new ListCollection(_currentUserTuningList);
            }
            _tuningList.setSize(actualWidth, actualHeight);
            _tuningList.y = actualHeight - _tuningList.height;
            if(openList){
                addChild(_tuningList);
            }
            if(tuning==null && openList){
                _tuningList.open();
            }else if(closeList){
                _tuningList.close(animate);
            }
        }
    }

    private function getListHeight():Number{
        return actualHeight/2 - 10;
    }


    private function searchTuning(str:String, collection:ListCollection):Array{
        var words:Array = str.toLowerCase().split(" ");
        var searchFunction:Function = function (element:*, index:int, arr:Array):Boolean {
            var tuning:Tuning = element as Tuning;
            var result:Boolean = true;
            var name:String = tuning.name.toLowerCase();
            for(var i:int = 0; i < words.length; i++){
                if(name.indexOf(words[i])==-1){
                    result = false;
                    break;
                }
            }
            return result;
        };
        var dataArray:Array = collection.data as Array;
        return dataArray.filter(searchFunction);
    }

    private function tuningSelectHandler(event:Event):void {
        if(_tuningList.searchResult.selectedItem) {
            SoundManager.playSound(SoundManager.SELECT_PART);
            setSelectedTuning(_tuningList.searchResult.selectedItem as Tuning);
        }
    }

    private function userSelectHandler(event:Event):void {
        if(_userList.searchResult.selectedItem) {
            SoundManager.playSound(SoundManager.SELECT_PART);
            setSelectedUser(Friend(_userList.searchResult.selectedItem).user);
            _avatar.x = _recipientLabel.x + _recipientLabel.width / 2 - _avatar.width / 2;
            _avatar.y = _recipientLabel.y - (_avatar.height + 15);
            _userList.close();
        }
    }

    override protected function draw():void {
        super.draw();
        if(_challengeLogo){
            _challengeLogo.x = (actualWidth - _challengeLogo.width) / 2;
            _challengeLogo.y = 20;

        }

        if(_vsLogo){
            _vsLogo.x = (actualWidth - _vsLogo.width) / 2;
            _vsLogo.y = (actualHeight - _vsLogo.height) / 2;
        }


        var gap:Number = 8;
        _confirmButton.x = actualWidth/2 - (_confirmButton.defaultSkin.width+gap);
        _cancelButton.x = actualWidth/2 + gap;
        var bottomGap:Number = 20;
        _confirmButton.y = _cancelButton.y = actualHeight - (_confirmButton.defaultSkin.height + bottomGap);
        _recipientLabel.y = _senderLabel.y = 2 * actualHeight / 3;
        var margin:Number = 29;
        if(_data.isInvitation){
            _senderLabel.x = actualWidth - (_senderLabel.width + margin);
            _recipientLabel.x = margin;
        }else{
            _recipientLabel.x = actualWidth - (_recipientLabel.width + margin);
            _senderLabel.x = margin;
        }

        //
        if(_randomUserImage){
            _randomUserImage.x = _recipientLabel.x + (_recipientLabel.width - _randomUserImage.width) / 2;
            _randomUserImage.y = _recipientLabel.y - (_randomUserImage.height + 15);
        }

        if(_defaultUserImage){
            _defaultUserImage.x = _recipientLabel.x + (_recipientLabel.width - _defaultUserImage.width) / 2;
            _defaultUserImage.y = _recipientLabel.y - (_defaultUserImage.height + 15);
        }

        if(_rulesButton){
            _rulesButton.validate();
            _cancelButton.validate();
            _rulesButton.x = actualWidth - (_rulesButton.width + 25);
            _rulesButton.y = _cancelButton.y + _cancelButton.height - _rulesButton.height;
        }

        if(_defaultTuningImage){
            _defaultTuningImage.x = _recipientLabel.x + (_recipientLabel.width - _defaultTuningImage.width)/2;
            _defaultTuningImage.y = _recipientLabel.y + 10 - _defaultTuningImage.height - (_defaultTuningImage.height < 125? (125 - _defaultTuningImage.height) / 2:0);
            if(!_data.isInvitation){
                _defaultTuningImage.x = _senderLabel.x + (_senderLabel.width - _defaultTuningImage.width)/2;
                _senderLabel.label = "CHOOSE YOUR CAR";
            }
        }

        if(_rewardedVotesImage){
            _rewardedVotesImage.x = margin;
            _rewardedVotesImage.y = _challengeLogo.y + _challengeLogo.height - 15;

            if(_challengeCoinsLabel){
                _challengeCoinsLabel.text = _currentUser.challengeCoins.toString();
                _challengeCoinsLabel.validate();
                _challengeCoinsLabel.x = _rewardedVotesImage.x + 42;
                _challengeCoinsLabel.y = _rewardedVotesImage.y + (_rewardedVotesImage.height - _challengeCoinsLabel.height) / 2;
            }
        }

        //
        if(_data.isInvitation){
            if(_avatar){
                _avatar.x = _senderLabel.x + _senderLabel.width - _avatar.width;
                _avatar.y = _senderLabel.y - 160;
                if(_senderUsernameLabel){
                    _senderUsernameLabel.x = _avatar.x - _senderUsernameLabel.width - 10;
                    _senderUsernameLabel.y = _avatar.y + (_avatar.height - _senderUsernameLabel.height) / 2;
                }
            }
        }else{
            if(_avatar){
                _avatar.x = _recipientLabel.x + _recipientLabel.width / 2 - _avatar.width / 2;
                _avatar.y = _recipientLabel.y - (_avatar.height + 15);
            }
        }

        if(_userList){
            _userList.setSize(actualWidth, getListHeight());
            userBorder.y = _userList.bannerSize;
            _userList.setChildIndex(userBorder, _userList.numChildren - 1);
        }

        if(closeButton){
            closeButton.x = actualWidth - (closeButton.width + gap);
            closeButton.y = gap;
        }

        if(!_isInvitation){
            if(!_randomChallengeSelect) {
                _randomChallengeSelect = ButtonFactory.challengeRadioButton('Random', null, "challenge_random_default", "challenge_random_select");
                _container.addChild(_randomChallengeSelect);
                _randomChallengeSelect.addEventListener(Event.CHANGE, randomChallengeChangeHandler);
                setTimeout(function():void{
                    invalidate("RandomChallenge");
                }, 30);
            }
            _randomChallengeSelect.x = _recipientLabel.x + (_recipientLabel.width - _randomChallengeSelect.width) / 2;
            _randomChallengeSelect.y = _recipientLabel.y + _recipientLabel.height + 5;
        }

        if(_challengeTypeLayout){
            _challengeTypeLayout.x = _senderLabel.x + (_senderLabel.width - _challengeTypeLayout.width) / 2;
            _challengeTypeLayout.y = _senderLabel.y + _senderLabel.height + 5;
        }
    }

    private function randomChallengeChangeHandler(event:Event):void {
        if(_randomChallengeSelect.isSelected){
            SoundManager.playSound(SoundManager.SELECT_PART);
            if(_avatar){
                _avatar.visible = false;
            }else if(_defaultUserImage){
                _defaultUserImage.visible = false;
            }
            if(_recipientLabel){
                _recipientLabel.label = "N/A";
            }
            if(!_randomUserImage){
                _randomUserImage = new Image(ButtonFactory.assetManager.getTexture("challenge_random_user"));
                _randomUserImage.width = _randomUserImage.height = 84;
            }
            _randomUserImage.x = _recipientLabel.x + (_recipientLabel.width - _randomUserImage.width) / 2;
            _randomUserImage.y = _recipientLabel.y - (_randomUserImage.height + 15);
            addChild(_randomUserImage);
        }else{
            SoundManager.playSound(SoundManager.SELECT_PART_BACK);
            if(_avatar){
                _avatar.alpha = 1;
                _avatar.visible = true;
            }else{
                _defaultUserImage.x = _recipientLabel.x + (_recipientLabel.width - _defaultUserImage.width) / 2;
                _defaultUserImage.y = _recipientLabel.y - (_defaultUserImage.height + 15);
                _defaultUserImage.visible = true;
            }
            if(_recipientLabel){
                _recipientLabel.alpha = 1;
                if(_avatar){
                    _recipientLabel.label = _avatar.user.nameToShow;
                }else{
                    _recipientLabel.label = "CHOOSE OPPONENT";
                }
            }
            if(_randomUserImage){
                _randomUserImage.removeFromParent();
            }
        }
        if(_recipientLabel) {
            _recipientLabel.isEnabled = !_randomChallengeSelect.isSelected;
        }
    }

    public static function getInstance(data:Object = null):StartChallengePopup{
        if(_instance){
            _instance.dispose();
        }
        _instance = new StartChallengePopup(data);
        return _instance;
    }

    private static function getLabel(isInvitation:Boolean = false):Button{
        var button:Button = new Button();
        var textureId:String = (isInvitation?"invitation_label_bg":"active_label_bg");
        var bg:Image = new Image(ButtonFactory.assetManager.getTexture(textureId));
        TextureUtil.scaleImage(bg, 0.5);
        var rectSize:Number = bg.texture.height/2-.5;
        bg.scale9Grid = new Rectangle(rectSize, rectSize, bg.texture.width-2*rectSize, 1);
        button.defaultSkin = bg;
        button.width = 190;
        button.height = bg.height;
        button.paddingLeft = bg.texture.height/2;
        button.verticalAlign = VerticalAlign.MIDDLE;
        button.gap = 10;
        if(!isInvitation) {
            button.iconOffsetX = -10;
            var arrow:Image = new Image(ButtonFactory.assetManager.getTexture("arrow_down"));
            arrow.scale = arrow.texture.scale / 2;
            button.defaultIcon = arrow;
            button.iconPosition = RelativePosition.RIGHT;
        }
        button.label = " ";
        var textColor:uint = isInvitation?0x848484:0x383838;
        button.labelFactory = function ():ITextRenderer {
            var textRenderer:TextFieldTextRenderer = new TextFieldTextRenderer();
            textRenderer.textFormat = new TextFormat(FontSelector.getMonserratMedium(), 10, textColor);
            textRenderer.textFormat.italic = false;
            textRenderer.textFormat.bold = false;
            textRenderer.embedFonts = true;
            textRenderer.wordWrap = false;
            textRenderer.textFormat.align = TextFormatAlign.CENTER;
            textRenderer.width = button.width-(button.paddingRight+button.paddingLeft+button.gap);
            return textRenderer;
        };
        return button;
    }

    private function ruleButtonTriggeredHandler(event:Event):void {
        var objToHide:Array = [
            _cancelButton,
            _confirmButton,
            _senderLabel,
            _recipientLabel,
            _selectedCar,
            _selectedCarImage,
            _senderCar,
            _senderCarImage,
            _avatar,
            _senderUsernameLabel,
            _vsLogo,
            _defaultTuningImage,
            _defaultUserImage,
            _challengeTypeLayout,
            _randomUserImage,
            _randomChallengeSelect
        ];
        //
        if(_rulesImage && _rulesImage.stage){
            Starling.juggler.tween(
                _rulesImage,
                0.15,
                {
                    alpha: 0,
                    transition: Transitions.LINEAR,
                    onComplete:function():void{
                        _rulesImage.removeFromParent();
                        _rulesBackButton.removeFromParent();
                        for(var i:int = 0; i < objToHide.length; i++){
                            if(objToHide[i]){
                                objToHide[i].visible = true;
                            }
                        }
                    }
                }
            );
        }else{
            for(var i:int = 0; i < objToHide.length; i++){
                if(objToHide[i]){
                    objToHide[i].visible = false;
                }
            }

            if(_avatar){
                _avatar.visible = false;
            }
            if(!_rulesImage){
                _rulesImage = new Image(ButtonFactory.assetManager.getTexture("challenge_rules"));
                _rulesImage.scale = ButtonFactory.assetManager.scaleFactor / 2;
                _rulesImage.color = 0xFF0000;
                if(_rulesImage.width > actualWidth - 2 * _rewardedVotesImage.x){
                    _rulesImage.width = actualWidth - 2 * _rewardedVotesImage.x;
                    _rulesImage.scale = _rulesImage.scaleX;
                }else if(_rulesImage.height > actualHeight - 2 * _rewardedVotesImage.y){
                    _rulesImage.height = actualHeight - 2 * _rewardedVotesImage.y;
                    _rulesImage.scale = _rulesImage.scaleY;
                }
            }
            _rulesImage.x = (actualWidth - _rulesImage.width) / 2;
            _rulesImage.y = _challengeLogo.y + _challengeLogo.height + 50;
            _rulesImage.alpha = 0;
            _container.addChild(_rulesImage);

            addChild(_rulesBackButton);
            _rulesBackButton.validate();
            _rulesBackButton.x = (actualWidth - _rulesBackButton.width) / 2;
            _rulesBackButton.y = _rulesImage.y + _rulesImage.height + 10;
            Starling.juggler.tween(
                    _rulesImage,
                    0.25,
                    {
                        alpha: 1,
                        transition: Transitions.EASE_OUT
                    }
            );
        }
    }
}
}
