package com.despark.tuning3d.view.components.core {
    import com.despark.tuning3d.view.components.NotificationView.InAppNotificationPopUp;
    import com.despark.tuning3d.view.components.timeline.FeedData;

    import feathers.controls.Button;
    import feathers.controls.Label;
    import feathers.controls.LayoutGroup;

    import starling.display.Image;
    import starling.textures.Texture;

    public class MainMenuItem extends Button {
    private var _noteCountGroup:LayoutGroup;
    private var _noteCountLabel:Label;
    public function MainMenuItem(textureName:String, prop:Object = null, countable:Boolean = false, iconColor:int = -1) {
        super();
        var _wt:Number = 28;
        var _ht:Number = 28;

        if (prop) {
            _wt = prop.w;
            _ht = prop.h;
        }
        width = _wt;
        height = _ht;

        var buttonTexture:Texture = ButtonFactory.assetManager.getTexture(textureName);
        var btnDefaultImg:Image = new Image(buttonTexture);
        var btnDownImg:Image = new Image(buttonTexture);
        btnDownImg.alpha = 0.6;
        if(iconColor != -1){
            btnDefaultImg.color = iconColor;
        }
        defaultSkin = btnDefaultImg;
        downSkin = btnDownImg;
        if(countable){
            _noteCountGroup = InAppNotificationPopUp.generateNotificationIcon();
            _noteCountGroup.visible = false;
            _noteCountGroup.x = 25;
            _noteCountGroup.y = -2;
            addChild(_noteCountGroup);
            for(var i:int = 0; i < _noteCountGroup.numChildren; i++){
                if(_noteCountGroup.getChildAt(i) is Label){
                    _noteCountLabel = _noteCountGroup.getChildAt(i) as Label;
                    break;
                }
            }
        }
    }

    public function set noteCount(val:int):void{
        if(_noteCountGroup) {
            _noteCountGroup.visible = (val > 0);
            if(_noteCountLabel)  {
                _noteCountLabel.text = FeedData.getNumberString(val);
                _noteCountLabel.validate();
                _noteCountGroup.width = Math.max(_noteCountLabel.width + 8, _noteCountGroup.height);
                _noteCountGroup.x = actualWidth - _noteCountGroup.height / 2 + 2;
            }
        }
    }

    public function get noteCount():int{
        if(_noteCountLabel)  {
            return parseInt(_noteCountLabel.text);
        }
        return 0;
    }
}
}
