package com.despark.tuning3d.view.components.core
{
import com.despark.tuning3d.ApplicationFacade;
import com.despark.tuning3d.Notifications;
import com.despark.tuning3d.model.challenges.ChallengesProxy;
import com.despark.tuning3d.model.core.AppMode;
import com.despark.tuning3d.model.core.Constants;
import com.despark.tuning3d.model.core.Constants;
import com.despark.tuning3d.model.core.Device;
import com.despark.tuning3d.model.friend.FriendProxy;
import com.despark.tuning3d.model.languages.Language;
import com.despark.tuning3d.model.languages.LanguagesProxy;
import com.despark.tuning3d.model.languages.Multilingual;
	import com.despark.tuning3d.model.mails.MailsProxy;
	import com.despark.tuning3d.model.sounds.SoundManager;
	import com.despark.tuning3d.model.users.User;
import com.despark.tuning3d.model.users.UsersProxy;
import com.despark.tuning3d.view.BrandsScreenMediator;
import com.despark.tuning3d.view.components.NotificationView.InAppNotificationPopUp;
	import com.despark.tuning3d.view.components.auth.ProfileAlertView;
	import com.despark.tuning3d.view.components.brands.BrandsScreen;
	import com.despark.tuning3d.view.components.challenges.ChallengesListScreen;
	import com.despark.tuning3d.view.components.friends.FriendsListPopUp;
import com.despark.tuning3d.view.components.gallery.GalleryScreen;
import com.despark.tuning3d.view.components.languages.LanguageItemRenderer;
	import com.despark.tuning3d.view.components.timeline.FeedData;
	import com.despark.tuning3d.view.components.timeline.TimelineScreen;
	import com.despark.tuning3d.view.components.timeline.components.UserCircularAvatar;
	import com.despark.tuning3d.view.components.tunings.TuningsListScreen;
import com.despark.tuning3d.view.components.tunings.editing.TuningScreen;
import com.despark.tuning3d.view.components.votes.VotesListScreen;
	import com.despark.tuning3d.view.core.StackedScreenExtendedMediator;
	import com.distriqt.AdsManager;
import com.utils.FontSelector;
import com.utils.ImageUtils;

import feathers.controls.Button;
import feathers.controls.Label;
import feathers.controls.LayoutGroup;
import feathers.controls.List;
import feathers.controls.PickerList;
import feathers.controls.ScrollBarDisplayMode;
import feathers.controls.ScrollContainer;
import feathers.controls.ScrollPolicy;
	import feathers.controls.ToggleButton;
	import feathers.controls.popups.DropUpPopUpContentManager;
import feathers.controls.renderers.IListItemRenderer;
import feathers.data.ListCollection;
import feathers.layout.HorizontalAlign;
import feathers.layout.HorizontalLayout;
import feathers.layout.VerticalAlign;
import feathers.layout.VerticalLayout;

import flash.display.Bitmap;
import flash.display.Loader;
import flash.events.IOErrorEvent;
import flash.events.TimerEvent;
import flash.geom.Rectangle;
import flash.net.URLRequest;
import flash.text.TextFormat;
import flash.text.TextFormatAlign;
import flash.utils.ByteArray;
import flash.utils.Timer;
import flash.utils.setTimeout;

import starling.animation.Transitions;
import starling.animation.Tween;
	import starling.core.Starling;
	import starling.core.Starling;
import starling.display.DisplayObjectContainer;
import starling.display.Image;
import starling.display.Quad;
import starling.display.Sprite;
import starling.events.Event;
import starling.events.EventDispatcher;
	import starling.events.Touch;
	import starling.events.TouchEvent;
	import starling.events.TouchPhase;
	import starling.textures.Texture;
import starling.utils.AssetManager;

public class MainMenuView extends StackedScreenNavigator implements Multilingual
	{
		public static var assetManager : AssetManager;
		public static var language : Language;

		public var garageThumbMode:Boolean = false;
		public var caller : *;

		private static var pickerButton2 : MultilingualButton = null;

		public var image : Sprite;
		public var isOpened : Boolean = false;

		public  var stateTimer:Timer;
		private var languageTimer:Timer;

		private var _text : String;
		private var _parentActualWidth:Number;
		private var _parentActualHeight:Number;

        public var frndButton : MainMenuItem;
		public var homeButton : Sprite;

		public var grgeButton : Button;
		public var shedButton : Button;
		public var challengeButton: Button;
		public var challengeNotesButton: MainMenuItem;
        public var timelineButton:Button;
        public var galleryButton:Button;
        public var notificationButton: MainMenuItem;
        public var mailsButton: MainMenuItem;
        public var pendingForAuthAction : String;

		private var backButton : MultilingualButton;
		public var loginButton : Button;
		public var soundSwitch : ToggleButton;
		public var pickerButton : MultilingualButton;
		public var avatarButton : UserCircularAvatar;
		public var toggleButton : MainMenuButton;
		public var avatarContainer:Sprite;
		private var userButtonContainer:LayoutGroup;

		private var _languages : Array;
		private var _languageList:List = null;

		public var languagePickerList : PickerList;
		public var logoutButton : Button;
		public var restoreButton : Button;
		private var overlay : Button;

		private var verticalOffset   : Number = 13;
		private var horizontalOffset : Number = 15;

		private var _userData : Object;
		private var itemCollection : Array;

		public var _language : Language = null;
		public var _selectedLanguage : Language;
		public var languageChangedHandlerDisabled : Boolean;

		private var verSpacer : Quad;
		private var _signedIN : Boolean = false;
		//public var avatarImage : Image = null;

		protected var loginSign  : int = -1;

		private var _owner : IMainMenuHolder;

        private var avatarLoader : Loader;
        private var isLoading   : Boolean = false;
        private var _dataLoaded : Boolean = false;

		private var completeShowCallback : Function = null;
        private var _buttonsContainer:ScrollContainer;

		private var _friendProxy:FriendProxy;
		public static const MENU_WIDTH:int = 205;
		public static const START_SHOW:String = 'startShow';
		public  function MainMenuView(obj:*=null)
		{
			super();

			if(Device.isIphoneXVariant()){
				horizontalOffset+=17;
			}

			if (obj) caller = obj;

			this.addEventListener(Event.ADDED_TO_STAGE, onAddedToStage);
            _friendProxy = ApplicationFacade.getInstance().retrieveProxy(FriendProxy.NAME) as FriendProxy;
			visible = false;
		}

        public function get customUserName() : String
		{
            var str : String = selectedLanguage.translate("mob_garage","myGarage").toUpperCase();
            if (Constants.selectedUser && Constants.selectedUser.username){
                MultilingualButton(getElement(grgeButton,"label")).label = Constants.selectedUser.username + " " + str.split(" ")[1];
				trace("customUserName:", Constants.selectedUser.username + " " + str.split(" ")[1]);
            }

            return str;
        }

		public function set owner(value : IMainMenuHolder)  : void {
			this._owner = value;
		}
		public function get owner():IMainMenuHolder{
			return this._owner;
		}

		public function get userSignedIn():Boolean{
			return (ApplicationFacade.getInstance().retrieveProxy(UsersProxy.NAME) as UsersProxy).currentUser != null;
		}

		private function onAddedToStage(event:Event) : void
		{
			this.removeEventListener(Event.ADDED_TO_STAGE, onAddedToStage);

			language = owner.selectedLanguage;
			languageChangedHandlerDisabled = true;

			hide();

			if (userSignedIn) {
				//loginButtonTriggeredHandler();
			}
		}

		public function get signedIN() : Boolean {
			_signedIN=userSignedIn;
			return userSignedIn;
		}
		public function set signedIN(value:Boolean):void{
			//	_signedIN = value;
		}

		public function get userData() : Object {
			return _userData;
		}
		public function set userData(value :Object):void{
			_userData = value;
		}

		public function get selectedLanguage() : Language {
			var ln:Language = _selectedLanguage||AlertView.language;
			return ln;
		}
		public function set selectedLanguage(value :Language):void{
			_selectedLanguage = value;
		}

		public function get languages() : Array {
			return _languages;
		}

		public function set languages(value:Array):void{
			_languages = value;
			invalidate("languages");
		}

		private function addElement(item:*,index:int=-1) : void
		{
			if (!itemCollection) {
				itemCollection = [];
			}

			for (var i:int = 0; i < itemCollection; i++) {
				if (itemCollection[i].name == item.name) {
					return;
				}
			}
			index != -1 ? addChildAt(item,index) : addChild(item);
		}

		public function get text() : String {
			return _text;
		}
		public function set text(value:String):void{
			_text = value;
			invalidate("text");
		}

		public function set parentActualWidth(value:Number):void{
			_parentActualWidth = value;
		}
		public function get parentActualWidth() : Number{
			return _parentActualWidth;
		}

		public function set parentActualHeight(value:Number):void{
			_parentActualHeight = value;
		}
		public function get parentActualHeight():Number{
			return _parentActualHeight;
		}

		private function onCheckStateTimer(event:TimerEvent=null) : void
		{

			signedIN = userSignedIn;

			var usersProxy : UsersProxy = ApplicationFacade.getInstance().retrieveProxy(UsersProxy.NAME) as UsersProxy;

			var eventDone : Boolean = false;
			if (loginSign == -1)
			{
				if (!signedIN)
				{
					signedIN  = false;
					eventDone = true;
				}
			}
			else
			{
				if (signedIN && null != usersProxy.currentUser)
				{

					var tempUser : User = usersProxy.currentUser as User;
					if (tempUser) {
						if(avatarButton){
							avatarButton.removeFromParent(true);
						}
						avatarButton = new UserCircularAvatar(tempUser, 25, true, 1);
						avatarContainer.addChild(avatarButton);
						avatarButton.y = 1;
						avatarButton.addEventListener(TouchEvent.TOUCH, avatarTouchHandler);
					}

					signedIN  = true;
					eventDone = true;

					updateWithLanguage(AlertView.language);

				}
			}

			if (eventDone)
			{
				if (stateTimer){
					stateTimer.stop();
					stateTimer.removeEventListener(TimerEvent.TIMER, onCheckStateTimer);
					stateTimer = null;
				}

				//updateStates();
				if (owner.mainMenuView) {
					owner.mainMenuView.updateStates();
				}


			}
		}

        public function loadImage(url:String) : void
        {
            if(url.indexOf("http") == - 1) url = "http:" + url;

            isLoading = true;
            avatarLoader = new Loader();
            avatarLoader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR, onIOErrorHandler);
            avatarLoader.contentLoaderInfo.addEventListener(flash.events.Event.COMPLETE,onLoadComplete);
            avatarLoader.load(new URLRequest(url));
        }

        private function onIOErrorHandler(event:IOErrorEvent):void
        {
            isLoading = false;
            avatarLoader.contentLoaderInfo.removeEventListener(flash.events.Event.COMPLETE,onLoadComplete);
            avatarLoader.contentLoaderInfo.removeEventListener(IOErrorEvent.IO_ERROR, onIOErrorHandler);
        }

        public  function onLoadComplete(event:flash.events.Event) : void
        {
            if (!isLoading) return;

            avatarContainer ||= new Sprite();
            avatarContainer.addChild(avatarButton);
			avatarButton.y = 1;
			isLoading = false;

            avatarLoader.contentLoaderInfo.removeEventListener(flash.events.Event.COMPLETE,onLoadComplete);
            avatarLoader.contentLoaderInfo.removeEventListener(IOErrorEvent.IO_ERROR, onIOErrorHandler);

            _dataLoaded = true;
            avatarButton.visible = false;

        }

		public function loginButtonTriggeredHandler(event:Event=null) : void {
			if (event) {
				SoundManager.playSound(SoundManager.SELECT_PART);
				pendingForAuthAction = BrandsScreenMediator.AUTH_ACTION_LOGIN;
				owner.dispatchExternalEvent(BrandsScreen.LOGIN_SELECTED);

				var target : MainMenuView = owner.mainMenuView;

				loginSign = 1;
				if (target.stateTimer) {
					target.stateTimer.stop();
					target.stateTimer.removeEventListener(TimerEvent.TIMER, onCheckStateTimer);
					target.stateTimer = null;
				}
				target.stateTimer = new Timer(40,0);
				target.stateTimer.addEventListener(TimerEvent.TIMER, onCheckStateTimer);
				target.stateTimer.start();
			} else {
				loginSign = 1;
				if (stateTimer) {
					stateTimer.stop();
					stateTimer.removeEventListener(TimerEvent.TIMER, onCheckStateTimer);
					stateTimer = null;
				}
				stateTimer = new Timer(40,0);
				stateTimer.addEventListener(TimerEvent.TIMER, onCheckStateTimer);
				stateTimer.start();
			}
		}

		private function logoutButtonTriggeredHandler(event:Event) : void {
			owner.dispatchExternalEvent(BrandsScreen.LOGOUT_SELECTED);
			if (owner is TuningsListScreen) {
				owner.dispatchExternalEvent(BrandsScreen.CLEANUP_MEMORY);
			}
			var target:MainMenuView = owner.mainMenuView;
			loginSign = -1;
			if(event){
				SoundManager.playSound(SoundManager.SELECT_PART_BACK);
			}
			if(target) {
                if (target.stateTimer) {
                    target.stateTimer.stop();
                    target.stateTimer.removeEventListener(TimerEvent.TIMER, onCheckStateTimer);
                    target.stateTimer = null;
                }
                target.stateTimer = new Timer(40, 0);
                target.stateTimer.addEventListener(TimerEvent.TIMER, onCheckStateTimer);
                target.stateTimer.start();
            }

			if (caller && caller.hasOwnProperty("homeButtonTriggeredHandler")){
				caller.homeButtonTriggeredHandler();
			}
		}

		public function profileButtonTriggeredHandler(event:Event) : void {
			SoundManager.playSound(SoundManager.PART_MENU);
			owner.dispatchExternalEvent(StackedScreen.USER_PROFILE_SELECTED);
		}

		public function newsButtonTriggeredHandler(event:Event) : void {
			SoundManager.playSound(SoundManager.PART_MENU);
			owner.dispatchExternalEvent(StackedScreen.NEWS_SELECTED);
		}

		public function restoreButtonTriggeredHandler(event:Event) : void {
			SoundManager.playSound(SoundManager.SELECT_PART);
            if (userSignedIn || Constants.isIOS) {
                owner.dispatchExternalEvent(StackedScreen.USER_RESTORE_SELECTED);
            } else {
                pendingForAuthAction = BrandsScreenMediator.AUTH_ACTION_LOGIN;
                owner.dispatchExternalEvent(BrandsScreen.LOGIN_SELECTED);
            }
		}

		public function updateStats():void{
            _friendProxy.loadPendings();
		}

		public function updateStates() : void
		{


			/*if (instructionButton && actualHeight){
				instructionButton.y = verticalOffset;
				instructionButton.x = _signedIN ? ((actualWidth - instructionButton.width) / 2 -horizontalOffset): ((actualWidth - 3 * instructionButton.width) / 2-horizontalOffset);
			}*/

			if (logoutButton && actualHeight){
				// logoutButton.y = verticalOffset;
			}

			if (languagePickerList){
				languagePickerList.width = 30;
				languagePickerList.height = 30;
				//languagePickerList.x = _signedIN ? actualWidth - logoutButton.width - 2*horizontalOffset : logoutButton.x + 2 * logoutButton.width;
				//languagePickerList.y = logoutButton.y; //actualHeight - logoutButton.height - verticalOffset;
			}

			if (signedIN)
			{
				loginButton.visible = false;
				soundSwitch.visible = false;
				logoutButton.visible = true;
                restoreButton.visible = true; // restore later
                verSpacer.visible = true;
				if(avatarButton){
					avatarButton.visible = true;
				}

				var usersProxy : UsersProxy = ApplicationFacade.getInstance().retrieveProxy(UsersProxy.NAME) as UsersProxy;
				var tempUser : User = usersProxy.currentUser as User;

				if (tempUser) {
					if(avatarButton){
						avatarButton.removeFromParent(true);
					}
					avatarButton = new UserCircularAvatar(tempUser, 25, true, 1);
					avatarContainer.addChild(avatarButton);
					avatarButton.addEventListener(TouchEvent.TOUCH, avatarTouchHandler);
					avatarButton.y = 1;
				}

				signedIN  = true;
				updateWithLanguage(AlertView.language);
			}
			else
			{
				loginButton.visible = true;
				soundSwitch.visible = true;
                logoutButton.visible = false;
                restoreButton.visible = true; // restore later
                verSpacer.visible = true;
				if(avatarButton){
					avatarButton.visible = false;
				}
			}

			invalidate();
		}

		private function updateItemsLanguage() : void
		{
			MultilingualButton(getElement(homeButton,"label")).label = selectedLanguage.translate("mob_home","home");
            MultilingualButton(getElement(grgeButton,"label")).label = customUserName;
            MultilingualButton(getElement(shedButton,"label")).label = selectedLanguage.translate("mob_home","Schedule").toUpperCase();

            MultilingualButton(getElement(challengeButton,"label")).label = "Challenges".toUpperCase();
            MultilingualButton(getElement(timelineButton,"label")).label = "Timeline".toUpperCase();
            MultilingualButton(getElement(galleryButton,"label")).label = "Gallery".toUpperCase();

			invalidate();

            /*MultilingualButton(getElement(frndButton,"label")).label = "Friends";*/
		}

		public function updateGaragLabel(str:String) : void {
            MultilingualButton(getElement(grgeButton,"label")).label = str;
		}

		public function updateWithLanguage(language:Language) : void
		{
			if(!language)
					return;
			//trace("updateWithLanguage", language)
			_language = language;

			if (backButton){
				backButton.updateWithLanguage(language);
			}

			if (pickerButton){
				pickerButton.updateWithLanguage(language);
			}

			if (pickerButton2){
				pickerButton2.updateWithLanguage(language);
			}

			updateItemsLanguage();
		}

		private function closeLangMenuButtonTriggeredHandler(event:Event):void
		{
			if (pickerButton2)
			{
				pickerButton2.alpha = 1.0;
				if (pickerButton2.disabledSkin) {
					pickerButton2.disabledSkin.alpha = 1.0;
				}
			}
			closeLanguagePickerList();
		}

		public function closeLanguagePickerList() : void
		{
			if (languagePickerList && languagePickerList.popUpContentManager) {
				languagePickerList.popUpContentManager.close();
			}
			languageChangedHandlerDisabled = false;
		}

		private function getElement(target:*,str:String) :*
		{
			if (!target || !target.numChildren) return null;

			for (var i:int = 0; i < target.numChildren; i++){
				if (target.getChildAt(i).name == str) return target.getChildAt(i);
			}
			return null;
		}

		private function onTouchOverlay(event:Event) : void {
			SoundManager.playSound(SoundManager.MENU_CLOSE);
			hide(true);
		}

		public function hide(animation:Boolean=false, time:Number=.1):void
		{
			BrandsScreen.adsBlocker = false;
			if (languagePickerList) {
				closeLanguagePickerList();
			}

			var target :* = !caller ? owner : caller;
			if (animation)
			{
				var tween : Tween = new Tween(target, .35, Transitions.EASE_IN_OUT);
					tween.moveTo(0,0);
					tween.onComplete = completeHide;
				Starling.juggler.add(tween);
			}
			else
			{
				target.x = 0;
				completeHide();
			}
		}

		private function completeHide() : void {
			if (overlay) {
				overlay.visible = false;
			}

			dispatchEventWith(Event.CLOSE);
			isOpened = false;
		}

		private function modeUpdate():void{
			if(AppMode.self.mode == AppMode.MODE_HOME){
                _buttonsContainer.addChildAt(shedButton, _buttonsContainer.getChildIndex(frndButton)+1);
			}else if(AppMode.self.mode == AppMode.MODE_TUNING) {
                shedButton.removeFromParent();
                _buttonsContainer.addChildAt(shedButton, _buttonsContainer.getChildIndex(frndButton)+1);
            }else if(AppMode.self.mode == AppMode.MODE_TRUCK_CONFIGURATOR){
				shedButton.removeFromParent();
				_buttonsContainer.addChildAt(shedButton, _buttonsContainer.getChildIndex(frndButton)+1);
            }else if(AppMode.self.mode == AppMode.MODE_AMERICAN_MUSCLE){
				shedButton.removeFromParent();
				_buttonsContainer.addChildAt(shedButton, _buttonsContainer.getChildIndex(frndButton)+1);
            }
		}

		public function show(animation:Boolean=false, complete:Function=null):void {
			SoundManager.playSound(SoundManager.MENU);

            modeUpdate();
			updateStates();
			completeShowCallback = complete;
			dispatchEventWith(START_SHOW);
			var target :* = !caller ? owner : caller;
			if (animation) {
				var tween : Tween = new Tween(target, .35, Transitions.EASE_IN_OUT);
				tween.moveTo(actualWidth,0);
				tween.onComplete = completeShow;
				Starling.juggler.add(tween);
			} else {
				target.x = actualWidth;
				completeShow();
			}
		}

		private function completeShow():void {
			dispatchEventWith(Event.OPEN);

			if (completeShowCallback) {
				completeShowCallback();
				completeShowCallback = null;
			}

			if (overlay) {
				overlay.visible = true;
			}
			isOpened = true;
		}

		private function homeButtonTriggered(event:Event=null) : void {
			SoundManager.playSound(SoundManager.SELECT_PART);
            owner.homeButtonTriggeredHandler();
		}


		private function instructionButtonTriggeredHandler(event : Event) : void {
			owner.dispatchExternalEvent(BrandsScreen.INSTRUCTION_SELECTED);
		}

		private function sheduleButtonTriggeredHandler(event:Event) : void {
			SoundManager.playSound(SoundManager.SELECT_PART);
			if (owner is VotesListScreen){
				hide(true);
			}else{
				owner.dispatchExternalEvent(StackedScreen.VOTE_SELECTED);
				setTimeout(function():void{
					owner.dispatchExternalEvent(BrandsScreen.CLEANUP_MEMORY);
				}, 1500);
			}
		}

		private function challengeButtonTriggeredHandler(event:Event) : void {
			SoundManager.playSound(SoundManager.SELECT_PART);
			if (owner is ChallengesListScreen){
				hide(true);
			}else{
				owner.dispatchExternalEvent(StackedScreen.CHALLENGES_SELECTED);
				setTimeout(function():void{
					owner.dispatchExternalEvent(BrandsScreen.CLEANUP_MEMORY);
				}, 1500);
			}
		}

		private function galleryButtonTriggeredHandler(event:Event) : void {
			SoundManager.playSound(SoundManager.SELECT_PART);
			if (owner is GalleryScreen){
				hide(true);
			}else{
				owner.dispatchExternalEvent(StackedScreen.GALLERY_SELECTED);
				setTimeout(function():void{
					owner.dispatchExternalEvent(BrandsScreen.CLEANUP_MEMORY);
				}, 1500);

			}
		}


		private function grgeButtonTriggeredHandler(event:Event) : void {
			SoundManager.playSound(SoundManager.SELECT_PART);
            var facade : ApplicationFacade = ApplicationFacade.getInstance();
            var usersProxy:UsersProxy= facade.retrieveProxy(UsersProxy.NAME) as UsersProxy;
			var currentUser:User =usersProxy.currentUser;
			var reloadGarage:Boolean = false;
			if(currentUser && Constants.selectedUser && Constants.selectedUser.id != currentUser.id){
                Constants.selectedUser = null;
				reloadGarage = true;
			}
			pendingForAuthAction = BrandsScreenMediator.AUTH_ACTION_GARAGE;
			if (owner is TuningsListScreen){
				if(reloadGarage){
                    TuningsListScreen(owner).dispatchEventWith(StackedScreenNavigator.BACK_TO_SCREEN);
                    var delayedCall:Function = function ():void {
                        pendingForAuthAction =  BrandsScreenMediator.AUTH_ACTION_GARAGE;
                        usersProxy.sendNotification(Notifications.DISPLAY_TUNINGS_LIST_SCREEN);
                        if(isLoading){
                            setTimeout(function():void{
                                owner.dispatchExternalEvent(BrandsScreen.CLEANUP_MEMORY);
                            },1500);
                        }
                    };
                    Starling.juggler.delayCall(delayedCall, 0.03);
				}else {
                    if (!garageThumbMode) {
                        owner.enterRowsState();
                    }
                    hide(true);
                }
			}else{
				if(owner as TuningScreen){
					pendingForAuthAction =  BrandsScreenMediator.AUTH_ACTION_GARAGE;
				}
				owner.dispatchExternalEvent(StackedScreen.GARAGE_SELECTED);
				//if(!owner as TuningScreen)
				if(isLoading){
					setTimeout(function():void{
						owner.dispatchExternalEvent(BrandsScreen.CLEANUP_MEMORY);
					},1500);
				}

			}
		}

		private  function onCheckForLanguage(event:TimerEvent):void {
			if (!owner.languages) return;

			//trace("onCheckForLanguage")

			languages = owner.languages;
			if (languages && languages.length > 0)
			{
				languageTimer.stop();
				languageTimer.removeEventListener(TimerEvent.TIMER, onCheckForLanguage);
				languageTimer = null;

				if (owner.selectedLanguage)
				{
					//trace("onCheckForLanguage2");
					selectedLanguage = owner.selectedLanguage;
					if (selectedLanguage /*&& isInvalid("languages") &&*/ && languages)
					{
						var index : int = -1;
						for (var i : int = 0; i < languages.length; i++){
							if (selectedLanguage.code == languages[i].code) {
								index = i;
								break;
							}
						}
					}

					setLanguageCollection(languages);
					languagePickerList.selectedIndex = index;
					invalidate();
				}
			}
		}

		private function setLanguageCollection(lnArr:Array):void{
			languagePickerList.removeEventListener(Event.CHANGE,languagePickerListChangeHandler);
			languagePickerList.dataProvider = new ListCollection(lnArr);
			languagePickerList.addEventListener(Event.CHANGE,languagePickerListChangeHandler);
		}

		public function languagePickerListChangeHandler(event :Event) : void
		{
			if (languageChangedHandlerDisabled) return;

			try {
				if (pickerButton2) pickerButton2.label = LanguageItemRenderer.getShortname(languagePickerList.selectedItem as Language);
			}
			catch(error:Error){
				//trace("MainMenuView.languagePickerListChangeHandler()",error.message);
			}

			if (/*selectedLanguage && */languagePickerList && languagePickerList.selectedItem && selectedLanguage != languagePickerList.selectedItem as Language)
			{
				selectedLanguage = languagePickerList.selectedItem as Language;
				language = selectedLanguage;

				Language.selectedLanguage = owner.selectedLanguage = selectedLanguage;
				owner.dispatchExternalEvent(BrandsScreen.LANGUAGE_CHANGED);
				owner.updateWithLanguage(owner.selectedLanguage);

				if (caller && caller.hasOwnProperty("updateWithLanguage")){
					caller.updateWithLanguage(selectedLanguage);
				}
			}

			closeLanguagePickerList()
		}

		private function getInstanceMemoryLocation(obj:*) : void
		{
			try {
				ByteArray(obj);
			}
			catch (error:Error){
				trace("hash:"+String(error).replace(/.*([@|\$].*?) to .*$/gi, '$1'));
			}
		}

		private function getItemLabel(target:*) : String{
			return MultilingualButton(getElement(target,"label")).label;
		}

		protected override function initialize() : void
		{
			super.initialize();

			languageChangedHandlerDisabled = true;
			this.x = -actualWidth;

			var size : Number = 28;
			var wdth : Number = actualWidth - 2 * horizontalOffset;
			if(Device.isIphoneXVariant()){
				wdth+=horizontalOffset-5;
			}
			var target : MainMenuView = owner.mainMenuView;

            var layout : VerticalLayout = new VerticalLayout();
            layout.gap = 0;
            layout.hasVariableItemDimensions = true;
            layout.horizontalAlign = HorizontalAlign.LEFT;
            layout.verticalAlign = VerticalAlign.TOP;

            _buttonsContainer  = new ScrollContainer();
            _buttonsContainer.layout = layout;
            _buttonsContainer.horizontalScrollPolicy = ScrollPolicy.OFF;
            _buttonsContainer.scrollBarDisplayMode = ScrollBarDisplayMode.FLOAT;
            _buttonsContainer.verticalScrollPolicy = ScrollPolicy.ON;

            if (caller)
			{
				if (!stateTimer){
					stateTimer = new Timer(40,0);
					stateTimer.addEventListener(TimerEvent.TIMER, onCheckStateTimer);
					stateTimer.start();
				}
				else{
					stateTimer.stop();
					stateTimer.start();
				}

				homeButton = ButtonFactory.mainMenuButton("home_btn",{w:wdth,h:size,t:getItemLabel(target.homeButton)});
                grgeButton = ButtonFactory.mainMenuButton("garage_button",{w:wdth,h:size,t:getItemLabel(target.grgeButton)});
				shedButton = ButtonFactory.mainMenuButton("shed_btn",{w:wdth,h:size,t:getItemLabel(target.shedButton)});
				challengeButton = ButtonFactory.mainMenuButton("challenges_btn",{w:wdth,h:size,t:getItemLabel(target.challengeButton)});
				challengeNotesButton = new MainMenuItem("globe",null, true);
				timelineButton = ButtonFactory.mainMenuButton("globe",{w:wdth,h:size,t:getItemLabel(target.timelineButton)});
                galleryButton = ButtonFactory.mainMenuButton("gallery_icon",{ w:wdth, h:size, t:getItemLabel(target.galleryButton)});
                frndButton = new MainMenuItem("users-solid",null, true);
                notificationButton = new MainMenuItem("clock-menu",null, true);
                mailsButton = new MainMenuItem("messages_btn",null, true);


				loginButton = ButtonFactory.circleButton("globe");
				loginButton.addEventListener(Event.TRIGGERED, loginButtonTriggeredHandler);
				loginButton.name = "loginButton";
				loginButton.setSize(28, 28);

                logoutButton = ButtonFactory.circleDefaultButton("logout", 0.6, 0xC80909, 0);

                restoreButton = ButtonFactory.circleDefaultButton("restore", 0.6, 0x0756B0, 0);
                restoreButton.scale = ButtonFactory.getMainMenuProfileButtonSize() / restoreButton.width;

				createSoundSwitchButton();


				verSpacer = new Quad(Device.isIphoneXVariant() ? homeButton.width-5 :homeButton.width,1.2,0xffffff);
				verSpacer.alpha = .45;

				loginSign = target.loginSign;
				signedIN  = target.signedIN;

				onCheckStateTimer();
			}

			overlay = new Button();
			overlay.defaultSkin = new Quad((Constants.STAGE_WIDTH - actualWidth), 1, 0x000000);
			overlay.defaultSkin.alpha = 0;
			overlay.addEventListener(Event.TRIGGERED, onTouchOverlay);
			overlay.visible = false;
			addChild(overlay);

			if (!LanguageItemRenderer.SHORT_LABEL) {
				LanguageItemRenderer.SHORT_LABEL={};
				LanguageItemRenderer.SHORT_LABEL['ru-RU'] = 'RUS';
				LanguageItemRenderer.SHORT_LABEL['en-US'] = 'ENG';
			}

			languagePickerList = new PickerList();

			languagePickerList.addEventListener(Event.CLOSE,function(event:Event) : void{});
			languagePickerList.addEventListener(Event.CHANGE,languagePickerListChangeHandler);
			languagePickerList.addEventListener(Event.OPEN,function(event:Event) : void {
				if (pickerButton2) pickerButton2.label = LanguageItemRenderer.getShortname(languagePickerList.selectedItem as Language);});
			languagePickerList.labelField = "name";
			languagePickerList.popUpContentManager = new DropUpPopUpContentManager();
			(languagePickerList.popUpContentManager as DropUpPopUpContentManager).gap = -15;

			pickerButton = ButtonFactory.circleButton("emptyButton") as ExtentedButton;


			languageChangedHandlerDisabled = false;
			languagePickerList.buttonFactory = function() : Button {return pickerButton;};
			languagePickerList.labelFunction = function(item:Object) : String {
				return LanguageItemRenderer.getShortname(item as Language);
			};
			languagePickerList.listFactory = function() : List
			{

				var texture:Texture = assetManager.getTexture("bgOfShareMenu");

				if(pickerButton2 && pickerButton2.parent) pickerButton2.removeFromParent(true);
				pickerButton2 = ButtonFactory.circleButton("emptyButton", 1.0) as ExtentedButton;
				pickerButton2.width  = languagePickerList.width;
				pickerButton2.height = languagePickerList.height;
				pickerButton2.addEventListener(Event.TRIGGERED,closeLangMenuButtonTriggeredHandler);



				var list : List = new List();
				_languageList = list;

				var layout : VerticalLayout = new VerticalLayout();
				//layout.manageVisibility = true;
				layout.useVirtualLayout = false;
				list.layout = layout;
				list.setSize(languagePickerList.width, 105);
				list.verticalScrollPosition = 0;
				list.paddingTop = 15;
				list.paddingBottom = 15;
				list.backgroundSkin = new Image(texture);
				(list.backgroundSkin as Image).scale9Grid = new Rectangle(0, 30, texture.frameWidth, 24); //tt возможно не правильно нужно для вертикальной позиции задать
				list.backgroundSkin.y = 0;
				list.itemRendererFactory = function() : IListItemRenderer {
					var renderer :	LanguageItemRenderer = new LanguageItemRenderer();
					renderer.setSize(languagePickerList.width, languagePickerList.height * 35 / 40);
					return renderer;
				};
				//list.addChild(pickerButton2);

				return list;
			};



			if (!_languages || caller && !languageTimer) {
				languageTimer = new Timer(40, 0);
				languageTimer.addEventListener(TimerEvent.TIMER, onCheckForLanguage);
				languageTimer.start();
			}

            if (!homeButton){
				homeButton = ButtonFactory.mainMenuButton("home_btn",{w:wdth,h:size,t:""});
				homeButton.name = "homeButton";
				homeButton.addEventListener(Event.TRIGGERED, homeButtonTriggered);
				_buttonsContainer.addChild(homeButton);
			}

            if (!galleryButton){
                galleryButton = ButtonFactory.mainMenuButton("gallery_icon",{w:wdth,h:size,t:""});
                galleryButton.name = "galleryButton";
                _buttonsContainer.addChild(galleryButton);
				galleryButton.addEventListener(Event.TRIGGERED, galleryButtonTriggeredHandler);
            }

            if (!notificationButton){
                notificationButton = new MainMenuItem("globe",null, true);
                notificationButton.name = "notificationButton";
				notificationButton.addEventListener(Event.TRIGGERED, notificationButtonTriggeredHandler);
                _buttonsContainer.addChild(notificationButton);

                updateNotificationCount();
            }

			if (!mailsButton){
				mailsButton = new MainMenuItem("messages_btn",null, true, 0xFFFFFE);
				mailsButton.name = "mailsButton";
				mailsButton.addEventListener(Event.TRIGGERED, mailButtonTriggeredHandler);
                _buttonsContainer.addChild(mailsButton);

                updateNotificationCount();
            }

            if (!challengeNotesButton){
                challengeNotesButton = new MainMenuItem("globe",null, true);
                challengeNotesButton.name = "challengeNotesButton";
				challengeNotesButton.addEventListener(Event.TRIGGERED, challengeNotesButtonTriggeredHandler);
                _buttonsContainer.addChild(challengeNotesButton);
            }

            if (!timelineButton){
                timelineButton = ButtonFactory.mainMenuButton("clock-menu",{w:wdth,h:size,t:""}, 0xFFFFFE);
                timelineButton.name = "timelineButton";
				timelineButton.addEventListener(Event.TRIGGERED, timelineButtonTriggeredHanlder);
                _buttonsContainer.addChild(timelineButton);
            }


			if (!challengeButton){
                challengeButton = ButtonFactory.mainMenuButton("challenges_btn",{w:wdth,h:size,t:""});
                challengeButton.name = "challengeButton";
				challengeButton.addEventListener(Event.TRIGGERED, challengeButtonTriggeredHandler);
                _buttonsContainer.addChild(challengeButton);
            }


            if (!grgeButton){
				grgeButton = ButtonFactory.mainMenuButton("garage_icon",{w:wdth,h:size,t:""}, 0xFFFFFE);
				grgeButton.name = "grgeButton";
				grgeButton.addEventListener(Event.TRIGGERED, grgeButtonTriggeredHandler);
				_buttonsContainer.addChild(grgeButton);
			}

            if (!frndButton){
                frndButton = new MainMenuItem("users-solid",null, true);
                frndButton.name = "friendButton";
                if(owner is EventDispatcher){
                    EventDispatcher(owner).addEventListener(FriendsListPopUp.PENDING_FRIENDS_READ, pendingFriendsLoadHandler);
                }
            }
			frndButton.addEventListener(Event.TRIGGERED,friendsButtonTriggeredHandler);
            _buttonsContainer.addChild(frndButton);

			if (!shedButton){
				shedButton = ButtonFactory.mainMenuButton("shed_btn",{w:wdth,h:size,t:""});
				shedButton.name = "sheduleButton";
				shedButton.addEventListener(Event.TRIGGERED, sheduleButtonTriggeredHandler);
            	_buttonsContainer.addChild(shedButton);
			}

            if (!logoutButton){
				logoutButton = ButtonFactory.circleDefaultButton("logout", 0.6, 0xC80909, 0);
				logoutButton.name = "logoutButton";
                logoutButton.addEventListener(Event.TRIGGERED, logoutButtonTriggeredHandler);
			}

			if (!restoreButton){
                restoreButton = ButtonFactory.circleDefaultButton("restore", 0.6, 0x0756B0, 0);
                restoreButton.scale = ButtonFactory.getMainMenuProfileButtonSize() / restoreButton.width;
                restoreButton.name = "profileButton";
                restoreButton.addEventListener(Event.TRIGGERED, restoreButtonTriggeredHandler);
			}
            logoutButton.visible = false;
            restoreButton.visible = true;

			if(!soundSwitch){
				createSoundSwitchButton();
			}
			soundSwitch.visible = false;

            userButtonContainer ||= new LayoutGroup();
			var buttonLayout:HorizontalLayout = new HorizontalLayout();
            buttonLayout.paddingTop = 3 * horizontalOffset / 2;
            buttonLayout.horizontalAlign = HorizontalAlign.LEFT;
            userButtonContainer.layout = buttonLayout;

            userButtonContainer.addChild(logoutButton);
            userButtonContainer.addChild(restoreButton);
            userButtonContainer.addChild(languagePickerList);
			userButtonContainer.addChild(soundSwitch);
			userButtonContainer.width = Device.isIphoneXVariant() ? homeButton.width-5: homeButton.width;
			if (languagePickerList) {
				trace("languagePickerList.dp", languagePickerList.dataProvider);
				languagePickerList.width  = 30;
				languagePickerList.height = 30;
			}

			if (!verSpacer){
				verSpacer = new Quad((Device.isIphoneXVariant() ? homeButton.width-5: homeButton.width),1.2,0xffffff);
				verSpacer.name = "verSpacer";
			}
			verSpacer.alpha = .45;
            avatarContainer ||= new Sprite();

			if (!loginButton){
				loginButton = ButtonFactory.circleButton("login");
				loginButton.addEventListener(Event.TRIGGERED, loginButtonTriggeredHandler);
				loginButton.name = "loginButton";
				loginButton.setSize(28, 28);
			}
			loginButton.visible = false;
            avatarContainer ||= new Sprite();
            avatarContainer.addChild(loginButton);
			if(avatarButton){
				avatarContainer.addChild(avatarButton);
				avatarButton.y = 1;
			}

			toggleButton = ButtonFactory.menuBigButton("a_back_button");
			toggleButton.visible=false;
			toggleButton.name = "toggleButton";
			toggleButton.width = toggleButton.height = 35;
			addElement(toggleButton);

            _buttonsContainer.addChild(avatarContainer);
            _buttonsContainer.addChild(userButtonContainer);
			addChild(_buttonsContainer);
            var buttonsLayout:VerticalLayout = new VerticalLayout();
            buttonsLayout.paddingBottom = 2*verticalOffset;
            _buttonsContainer.layout = buttonsLayout;
			updateStates();

			_selectedLanguage = AlertView.language;
			updateItemsLanguage();
		}

		private function createSoundSwitchButton():void {
			soundSwitch = new ToggleButton();
			soundSwitch.defaultSkin = new Quad(1,1,0xFF0000);
			soundSwitch.defaultSkin.alpha = 0;
			var defaultIcon:Image = new Image(ButtonFactory.assetManager.getTexture("sound_on_icon"));
			defaultIcon.scale = ButtonFactory.assetManager.scaleFactor / 2;
			soundSwitch.defaultIcon = defaultIcon;
			var defaultSelectedIcon:Image = new Image(ButtonFactory.assetManager.getTexture("sound_off_icon"));
			defaultSelectedIcon.scale = ButtonFactory.assetManager.scaleFactor / 2;
			soundSwitch.defaultSelectedIcon = defaultSelectedIcon;
			soundSwitch.width = soundSwitch.height = ButtonFactory.getMainMenuProfileButtonSize();
			soundSwitch.addEventListener(Event.CHANGE, soundChangeHandler);
			soundSwitch.isSelected = SoundManager.isMute;
		}

		private function soundChangeHandler(event:Event):void {
			SoundManager.soundMute(soundSwitch.isSelected);
			if(!soundSwitch.isSelected){
				SoundManager.playSound(SoundManager.SELECT_PART);
			}
		}

        private function pendingFriendsLoadHandler(event:Event):void {
			var changed:Boolean = (frndButton.noteCount > 0);
			if(event.data && event.data.hasOwnProperty("unread") && event.data.unread){
				frndButton.noteCount = Constants.UNREAD_FRIEND_REQUESTS = event.data.friends.length;
			}else{
                frndButton.noteCount = Constants.UNREAD_FRIEND_REQUESTS = 0;
			}
			if(changed != frndButton.noteCount==0){
				updateNotificationCount();
			}
        }

        private function timelineButtonTriggeredHanlder(event:Event):void {
			SoundManager.playSound(SoundManager.SELECT_PART);
            pendingForAuthAction = BrandsScreenMediator.AUTH_ACTION_TIMELINE;
            if (owner is TimelineScreen){
                hide(true);
            } else {
                owner.dispatchExternalEvent(StackedScreen.TIMELINE_SECLECTED);
            }
        }


        private function notificationButtonTriggeredHandler(event:Event):void {
			SoundManager.playSound(SoundManager.SELECT_PART);
            pendingForAuthAction = BrandsScreenMediator.AUTH_ACTION_NOTIFICATIONS;
            owner.dispatchExternalEvent(StackedScreen.NOTIFICATION_SELECTED);
        }

		private function mailButtonTriggeredHandler(event:Event):void {
			SoundManager.playSound(SoundManager.SELECT_PART);
            pendingForAuthAction = StackedScreenExtendedMediator.AUTH_ACTION_MAILS;
            owner.dispatchExternalEvent(StackedScreen.MAILS_SELECTED);
        }

		private function challengeNotesButtonTriggeredHandler(event:Event):void {
			SoundManager.playSound(SoundManager.SELECT_PART);
            pendingForAuthAction = BrandsScreenMediator.AUTH_ACTION_CHALLENGE_NOTIFICATIONS;
            owner.dispatchExternalEvent(StackedScreen.CHALLENGE_NOTIFICATIONS_SELECTED);
        }

		public function leaderBoardButtonTriggeredHandler(event:Event):void {
			SoundManager.playSound(SoundManager.SELECT_PART);
            owner.dispatchExternalEvent(StackedScreen.LEADER_BOARD_SELECTED);
        }

        private function friendsButtonTriggeredHandler(event:Event) : void {
			SoundManager.playSound(SoundManager.SELECT_PART);
            pendingForAuthAction = BrandsScreenMediator.AUTH_ACTION_FRIENDS;
            if (owner is FriendsListPopUp){
                hide(true);
            }else{
                owner.dispatchExternalEvent(StackedScreen.FRIENDS_SELECTED);
            }
        }

        public function updateNotificationCount() : void{
			if(notificationButton){
                if (UsersProxy.loggedInUser()) {
                    notificationButton.noteCount = Constants.UNREAD_COMMON_NOTIFICATIONS
                } else {
                    Constants.UNREAD_COMMON_NOTIFICATIONS = 0;
                    notificationButton.noteCount = 0;
                }
			}

			if(challengeNotesButton) {
                if (UsersProxy.loggedInUser()) {
                    updateChallengeNotificationCount();
                } else {
                    challengeNotesButton.noteCount = 0;
                }
            }

			if(mailsButton) {
				if (UsersProxy.loggedInUser()) {
					updateMailCount();
				} else {
					mailsButton.noteCount = 0;
				}
            }

			if(toggleButton){
                toggleButton.updateNotification();
            }
        }

		public function updateChallengeNotificationCount():void{
            var facade : ApplicationFacade = ApplicationFacade.getInstance();
            var challengesProxy:ChallengesProxy= facade.retrieveProxy(ChallengesProxy.NAME) as ChallengesProxy;
            challengesProxy.getAllUnreadNotificationCount(function (count:int):void {
                MainMenuItem(challengeNotesButton).noteCount = count;
            });
		}

		public function updateMailCount():void{
            var facade : ApplicationFacade = ApplicationFacade.getInstance();
            var mailsProxy:MailsProxy = facade.retrieveProxy(MailsProxy.NAME) as MailsProxy;
            mailsProxy.getUnreadCount(function (count:int):void {
                MainMenuItem(mailsButton).noteCount = count;
            });
		}

		override protected function draw() : void {
			super.draw();

			if (isInvalid(INVALIDATION_FLAG_SIZE))
			{
				overlay.x = actualWidth;
				overlay.width = parentActualWidth - actualWidth;
				overlay.height = actualHeight;

				toggleButton.x = actualWidth + horizontalOffset / 2;
				toggleButton.y = verticalOffset / 2;

				_buttonsContainer.x = horizontalOffset;
				_buttonsContainer.y = 0;
				_buttonsContainer.height = actualHeight /**.6*/;


				if(AlertView.language){

					if(pickerButton){
						pickerButton.updateWithLanguage(AlertView.language);
					}

					if(pickerButton2){
						pickerButton2.updateWithLanguage(AlertView.language);
					}
				}

				if (languagePickerList) {

					var facade : ApplicationFacade = ApplicationFacade.getInstance();
					var langProxy:LanguagesProxy= facade.retrieveProxy(LanguagesProxy.NAME) as LanguagesProxy;

					if(langProxy.defaultLanguageCode=="en-US"){
						languagePickerList.visible = false;
					}

					if(!languagePickerList.dataProvider){


						if(langProxy.languages && AlertView.language){

							var index : int = -1;
							if (AlertView.language /*&& isInvalid("languages") &&*/ && langProxy.languages)
							{

								for (var i : int = 0; i < langProxy.languages.length; i++){
									if (AlertView.language.code == langProxy.languages[i].code) {
										index = i;
										break;
									}
								}
							}

							setLanguageCollection(langProxy.languages);
							languagePickerList.selectedIndex = index;
						}
					}
					languagePickerList.width = 30;
					languagePickerList.height = 30;
					languagePickerList.validate();
				}

				if(languagePickerList && languagePickerList.selectedItem)
				if (pickerButton2) pickerButton2.label = LanguageItemRenderer.getShortname(languagePickerList.selectedItem as Language);

				if(userButtonContainer){
					var btnCount:int = -1;
					var btnWidth:Number = 0;
					var j:int;
					for(j = 0; j < userButtonContainer.numChildren; j++){
						if(userButtonContainer.getChildAt(j).visible){
							btnWidth += userButtonContainer.getChildAt(j).width;
                            btnCount ++;
						}
					}

                    verSpacer.visible = (btnCount != -1);
                    if(btnCount >= 1) {
                        var btnGap:Number = (userButtonContainer.width - btnWidth) / btnCount;
						var btnX:Number = 0;
                        for(j = 0; j < userButtonContainer.numChildren; j++){
                            if(userButtonContainer.getChildAt(j).visible){
                                userButtonContainer.getChildAt(j).x = btnX;
                                btnX += userButtonContainer.getChildAt(j).width + btnGap;
                            }
                        }
                    }else{
                        for(j = 0; j < userButtonContainer.numChildren; j++){
                            if(userButtonContainer.getChildAt(j).visible){
                                userButtonContainer.getChildAt(j).x = 0;
                                break;
                            }
                        }
					}
				}
			}
		}

		private function avatarTouchHandler(event:TouchEvent):void {
			var touch:Touch = event.getTouch(avatarButton, TouchPhase.ENDED);
			if(touch){
				AlertView.show("Are you sure you want to log out?", 0, false, function (value:Boolean):void {
					if(value){
						logoutButtonTriggeredHandler(null);
					}
				}, false);

			}
		}
	}
}
